jQuery.validator.addMethod("alwaysFalse", function (value, element) {
    return false;
}, 'Always false');

jQuery.validator.addMethod("unique", function (value, element) {
    var ret = false;
    var arrId = element.id.split("__");
    var id = $("#ID").val();
    if ($(element).attr("data-uniqueid") !== undefined)
        id = $(element).attr("data-uniqueid");
    $.ajax({
        url: "/application/ajax/checkUniqueField.php",
        async: false,
        type: "POST",
        data: {class: arrId[0], ID: id, field: arrId[1], value: value, auxField: $("#" + $(element).attr("auxfield")).val()},
        dataType: "json",
        success: function (data) {
            if (data.result > 0)
                ret = true;
        }
    });
    return ret;
}, 'El valor introducido ya está en uso.');

jQuery.validator.addMethod("uniqueNIF", function (value, element) {
    var ret = false;
    var arrId = element.id.split("__");
    $.ajax({
        url: "/application/ajax/checkUniqueField.php",
        async: false,
        type: "POST",
        data: {class: arrId[0], ID: $("#ID").val(), field: arrId[1], value: value, FORM_PARENT_CUSTOMER_ID: $("#" + arrId[0] + "__PARENT_CUSTOMER_ID").val(), TYPE: $("#TYPE").val()},
        dataType: "json",
        success: function (data) {
            if (data.result > 0)
                ret = true;
        }
    });
    return ret;
}, 'El valor introducido ya está en uso.');

jQuery.validator.addMethod("uniqueAddress", function (value, element) {
    var ret = false;
    var arrId = element.id.split("__");
    $.ajax({
        url: "/application/ajax/checkUniqueField.php",
        async: false,
        type: "POST",
        data: {class: arrId[0], ID: $("#ID").val(), field: arrId[1], value: value, CUSTOMER_ID: $("#" + arrId[0] + "__CUSTOMER_ID").val()},
        dataType: "json",
        success: function (data) {
            if (data.result > 0)
                ret = true;
        }
    });

    return ret;
}, 'El valor introducido ya está en uso.');

jQuery.validator.addMethod("minlength-4", function (value, element) {
    if (value.length >= 4)
        return true;
    return false;

}, 'Por favor, no escribas menos de 4 caracteres.');

jQuery.validator.addMethod("validImage", function (value, element) {
    if ($(element).val() === "") {
        return true;
    }

    if (value.indexOf('\'') >= 0 || jQuery.inArray($(element).val().toUpperCase().split('.').pop(), AppConfig["imageAllowedExtensions"]) === -1) {
        $.validator.messages["validImage"] = 'Tipo de imagen no permitida o el nombre contiene comillas.';
        return false;
    }

    try {
        if (element.files[0].size <= 0) {
            $.validator.messages["validImage"] = 'No se permiten ficheros vacíos';
            return false;
        } else if (element.files[0].size > AppConfig["fileUploadMaxSize"]) {
            $.validator.messages["validImage"] = 'Tamaño máximo permitido' + ' ' + (AppConfig["fileUploadMaxSize"] / 1024 / 1024) + "MB";
            return false;
        }
    } catch (e) {
        console.log(e.message);
    }

    return true;

}, '');

jQuery.validator.addMethod("validFile", function (value, element) {
    if ($(element).val() === "")
        return true;

    if (value.indexOf('\'') >= 0 || jQuery.inArray($(element).val().toUpperCase().split('.').pop(), AppConfig["fileDeniedExtendions"]) !== -1) {
        $.validator.messages["validFile"] = 'Tipo de fichero no permitido o el nombre contiene comillas.';
        return false;
    }

    try {
        if (element.files[0].size <= 0) {
            $.validator.messages["validFile"] = 'No se permiten ficheros vacíos';
            return false;
        } else if (element.files[0].size <= 0 || element.files[0].size > AppConfig["fileUploadMaxSize"]) {
            $.validator.messages["validFile"] = 'Tamaño máximo permitido' + ' ' + (AppConfig["fileUploadMaxSize"] / 1024 / 1024) + "MB";
            return false;
        }
    } catch (e) {
        console.log(e.message);
    }

    return true;
}, '');

jQuery.validator.addMethod("validFilePDF", function (value, element) {
    if ($(element).val() === "") {
        return true;
    }
    if ($(element).val().toUpperCase().split('.').pop() !== "PDF") {
        $.validator.messages["validFilePDF"] = 'Tipo de fichero debe ser PDF.';
        return false;
    }
    return true;
}, '');

jQuery.validator.addMethod("valid-datepicker-value", function (value, element) {
    if ($(element).val() === "" || !$(element).hasClass("hasDatepicker")) {
        return true;
    }
    try {
        var format = $(element).datepicker('option', 'dateFormat');
        $.datepicker.parseDate(format, value);
    } catch (e) {
        $.validator.messages["valid-datepicker-value"] = 'Formato incorrecto.';
        return false;
    }

    return true;
}, '');

jQuery.validator.addMethod("valid-start-end-date", function (value, element) {
    if (value === "" || !$(element).attr("compareDateWithField") || !$(element).attr("compareDateWithOperator") || !$(element).hasClass("hasDatepicker")) {
        return true;
    }

    var className = $(element).attr("id").split("__")[0];
    var targetElement = $("#" + className + "__" + $(element).attr("compareDateWithField"));
    var operator = $(element).attr("compareDateWithOperator");
    if (!targetElement.length || targetElement.val() === "" || !targetElement.hasClass("hasDatepicker")) {
        return true;
    }
    var timeDiff = $(element).datepicker('getDate') - targetElement.datepicker('getDate');

    if (operator === "GREAT_EQUAL" && timeDiff < 0) {
        $.validator.messages["valid-start-end-date"] = '>=' + targetElement.val();
        return false;
    } else if (operator === "LESS_EQUAL" && timeDiff > 0) {
        $.validator.messages["valid-start-end-date"] = '>=' + targetElement.val();
        return false;
    } else {
        $.validator.messages["valid-start-end-date"] = '';
    }
    return true;
}, '');

jQuery.validator.addMethod("valid-url", function (value, element) {
    if (value === "") {
        return true;
    }
    return /^(http|https):\/\/.*$/i.test(value);
}, 'La URL debe comenzar por http:// o por https://');

jQuery.validator.addMethod("valid-calendar-url", function (value, element) {
    if (value === "") {
        return true;
    }
    return /^(http|https|webcal):\/\/.*$/i.test(value);
}, 'La URL debe comenzar por http://, por https:// o por webcal://');

jQuery.validator.addMethod("no-cero", function (value, element) {
    if (parseFloat(value) === 0)
        return false;
    return true;
}, '<> 0');

jQuery.validator.addMethod("required-no-cero", function (value, element) {
    if (value === '' || parseFloat(value) === 0)
        return false;
    return true;
}, 'Obligatorio');

jQuery.validator.addMethod("min-cero", function (value, element) {
    if (parseFloat(value) < 0)
        return false;
    return true;
}, '> 0');

jQuery.validator.addMethod("max-cero", function (value, element) {
    if (parseFloat(value) > 0)
        return false;
    return true;
}, '< 0');

jQuery.validator.addMethod("number-precision", function (value, element) {

    var maxDecimalsAllowed = ($(element).data("max-decimals") ? $(element).data("max-decimals") : AppConfig["unitPriceDecimals"]);
    var numberDecimals = ((value.indexOf('.') === -1) ? 0 : value.substring(value.indexOf('.')+1, value.length));

    if (numberDecimals.length > maxDecimalsAllowed)
    {
        var errorMsg = 'Sólo se pueden indicar __MAX_DECIMALS__ decimales.';         
        $.validator.messages["number-precision"] = errorMsg.replace("__MAX_DECIMALS__",maxDecimalsAllowed);         
        return false;
    }
    return true;
}, '');

jQuery.validator.addMethod("strong-password", function (value, element) {
    if (value === "") {
        return true;
    }
    return (value.length >= 8 && /[a-z]/.test(value) && /[A-Z]/.test(value) && /\d/.test(value));
}, 'Inserte al menos 8 caracteres usando números, mayúsculas y minúsculas.');

jQuery.validator.addMethod("checkValidObject", function (value, element) {
    var json = callClassMethod($("#objectForm").serialize() + "&class=CoreObject&method=checkValidObject");
    var res = $.parseJSON(json);

    if (res.result > 1)
    {
        $("#cmd").after(res.html);
        return true;
    } else if (res.result == 1)
    {
        return true;
    } else
    {
        $.validator.messages["checkValidObject"] = res.error;
        return false;
    }

}, '');

jQuery.validator.addMethod("multiemail", function (value, element) {
    if (this.optional(element)) {
        return true;
    }

    var emails = value.split(';'),
            valid = true;

    for (var i = 0, limit = emails.length; i < limit; i++) {
        value = emails[i];
        valid = valid && jQuery.validator.methods.email.call(this, value, element);
    }

    return valid;
}, "Email");

jQuery.validator.addMethod("lettersNumbers", function (value, element) {
    return this.optional(element) || /^[a-z0-9]+$/i.test(value);
}, "Solo letras y números.");

jQuery.validator.addMethod("integer", function (value, element) {
    return this.optional(element) || /^-?\d+$/.test(value);
}, "Solo número entero");
