function initAppDatatables()
{
    if (AppConfig["templateThemeVersion"] >= 3) {
        if ($('.cart-table-responsive').length) {
            $('.cart-table-responsive').attr("dtordering", "0").attr("dtPaginate", "0").attr("dtFilter", "0").attr("dtInfo", "0").attr("dtResponsive", "1").addClass("data-table");
        }
    }

    $('.data-table').each(function () {
        appDatatable($(this));
    });
    $(".data-table").each(function () {
        if ($(this).attr("dtGroup")) {
            var valueDtGroup = $(this).attr("dtGroup");
            $(document).on("keyup", "#" + $(this).attr("id") + "_filter input", function () {
                var valueSearch = $(this).val();
                $(".data-table").each(function () {
                    if (valueDtGroup === $(this).attr("dtGroup")) {
                        $("#" + $(this).attr("id")).DataTable().search(
                                valueSearch
                                ).draw();
                    }
                });
            });
        }
    });
    $('.data-table-server-side').each(function () {
        appDatatableServerSide($(this));
    });
    $('.data-table-scroller-server-side').each(function () {
        appDatatableScrollerServerSide($(this));
    });
}
function appDatatable(table)
{
    if ($.fn.DataTable.isDataTable(table))
    {
        return false;
    }

    if (AppConfig["templateThemeVersion"] >= 3) {
        /* Atributos para la versión V3 y posteriores */
        if (typeof table.attr("dynamicColumnsIfV3Version") !== "undefined" && table.attr("dynamicColumnsIfV3Version") === "1") {
            table.attr("dtDynamicColumns", "1");
        }
        if (typeof table.attr("dtExcelExportIfV3Version") !== "undefined" && table.attr("dtExcelExportIfV3Version") === "1") {
            table.attr("dtExcelExport", "1");
        }
    }

    var tableTbody = table.find("tbody").first();
    if (tableTbody.length) {
        $.each(tableTbody[0]["attributes"], function (i, a) {
            if (a.name.substring(0, 2) === "dt") {
                (a.value === "undefined" ? table.removeAttr(a.name) : table.attr(a.name, a.value));
            }
        });
    }

    if (typeof table.attr("dtRemoveContainerHeight") !== "undefined" && table.attr("dtRemoveContainerHeight") === "1") {
        table.parent().css({"height": "", "max-height": ""});
    }

    var bStateSave = true;
    if (typeof table.attr("dtStateSave") !== "undefined" && table.attr("dtStateSave") === "0")
    {
        bStateSave = false;
    }

    var autoWidth = false;
    if (typeof table.attr("dtautoWidth") !== "undefined" && table.attr("dtautoWidth") === "1")
    {
        autoWidth = true;
    }

    var ordering = true;
    if (typeof table.attr("dtordering") !== "undefined" && table.attr("dtordering") === "0")
    {
        ordering = false;
    }

    var arrDtOrder = ["0", "asc"];
    if (typeof table.attr("dtorder") !== "undefined")
    {
        arrDtOrder = table.attr("dtorder").split("-");
    }

    var notOrderableColumns = [];
    if (typeof table.attr("dtorderLastColumn") === "undefined" || table.attr("dtorderLastColumn") !== "1")
    {
        notOrderableColumns.push(-1);
    }
    if (typeof table.attr("dtorderFirstColumn") !== "undefined" && table.attr("dtorderFirstColumn") === "0")
    {
        notOrderableColumns.push(0);
    }
    if (typeof table.attr("dtNotSortableColumns") !== "undefined" && table.attr("dtNotSortableColumns") !== "")
    {
        var dtNotSortableColumns = table.attr("dtNotSortableColumns").split(",");
        $.each(dtNotSortableColumns, function (k, v) {
            notOrderableColumns.push(v * 1);
        });
    }

    var bPaginate = true;
    if (typeof table.attr("dtPaginate") !== "undefined" && table.attr("dtPaginate") === "0" && (typeof table.attr("dtServerSideData") === "undefined" || table.attr("dtServerSideData") === "0"))
    {
        bPaginate = false;
    }

    var iDisplayLength = (typeof table.attr("dtIDisplayLength") !== "undefined" ? table.attr("dtIDisplayLength") : null);

    var bFilter = true;
    if (typeof table.attr("dtFilter") !== "undefined" && table.attr("dtFilter") === "0")
    {
        bFilter = false;
    }

    var info = true;
    if (typeof table.attr("dtInfo") !== "undefined" && table.attr("dtInfo") === "0")
    {
        info = false;
    }

    var scrollX = false;
    if (typeof table.attr("dtScrollX") !== "undefined" && table.attr("dtScrollX") === "1")
    {
        scrollX = true;
    }

    var subtotalCalc = false;
    if (typeof table.attr("dtSubtotalCalc") !== "undefined" && table.attr("dtSubtotalCalc") === "1")
    {
        subtotalCalc = true;
    }

    var dom = "<'width-100 dt-header'lf><'width-100'<'width-100 div-table-container'tr>><'width-100 dt-footer'ip>";
    var buttons = [];
    if (typeof table.attr("dtExcelExport") !== "undefined" && table.attr("dtExcelExport") === "1") {
        /* Nombre del excel por defecto */
        var excelTitle = "Table-Excel";
        if (typeof table.attr("dtExcelExportTitle") !== "undefined" && table.attr("dtExcelExportTitle") !== "")
        {
            /* Si le pasamos nombre del Excel */
            excelTitle = table.attr("dtExcelExportTitle");
        } else if (AppConfig["templateThemeVersion"] >= 3)
        {
            /* vamos a buscar el panel heading mas cercano y si le tenemos ponemos su texto*/
            var tableClosestPanelHeading = table.closest(".panel").find(".panel-heading");
            if (tableClosestPanelHeading.length) {
                excelTitle = tableClosestPanelHeading.text();
            }
        }
        buttons.push({extend: 'excel', title: excelTitle,
            exportOptions: {format: {body: function (data, column, row, node) {
                        if (!data || typeof data !== "string") {
                            return data;
                        }
                        if (data.indexOf("<select") !== -1) {
                            if ($(data).val() !== "") {
                                return $(data).find("option:selected").text();
                            } else {
                                return "";
                            }
                        } else if (data.indexOf("<input") !== -1 && data.indexOf('type="text"') !== -1) {
                            return $(data).val();
                        } else if (data.indexOf('class="btn') !== -1) {
                            return "";
                        } else if ($.isNumeric(data.replace(/\./g, '').replace(',', '.'))) {
                            return data.replace(/\./g, '').replace(',', '.');
                        } else {
                            /*Quitamos los posibles html tags y sustituimos saltos de linea html*/
                            return $('<p>' + data.replace(/<br\s*[\/]?>/gi, "\n") + '</p>').text();
                        }
                    }}}
        });
    }
    if (typeof table.attr("dtDynamicColumns") !== "undefined" && table.attr("dtDynamicColumns") === "1") {
        buttons.push('wolfDynamicColumns');
    }

    if (buttons.length > 0) {
        dom = "<'width-100 dt-header'lBf><'width-100'<'width-100 div-table-container'tr>><'width-100 dt-footer'ip>";
    }

    var responsive = false;
    if (typeof table.attr("dtResponsive") !== "undefined" && table.attr("dtResponsive") === "1") {
        responsive = true;
        table.removeClass("table-striped");
        table.addClass("table-hover");
    }

    if (table.attr("dtDisableUpdateOptions") !== "1")
    {
        var totalRows = $(table).find("tbody").children().length;
        if (totalRows <= 10) {
            bPaginate = false;
            bFilter = false;
            info = false;
        }
    }

    var fixedHeaderOffset = 0;
    if (table.closest(".has-wolf-scroll-bar").length) {
        fixedHeaderOffset = fixedHeaderOffset + table.closest(".has-wolf-scroll-bar").offset().top;
    } else if ($("#content-container").length) {
        var contentContainerPadding = parseInt($("#content-container").css("padding-top"));
        if (!isNaN(contentContainerPadding)) {
            fixedHeaderOffset = fixedHeaderOffset + contentContainerPadding;
        }
    }

    var dataTableOptions = {
        "ordering": ordering,
        "aaSorting": [[arrDtOrder[0], arrDtOrder[1]]],
        "lengthMenu": [[10, 20, 25, 50, 100, 200, -1], [10, 20, 25, 50, 100, 200, 'Todos']],
        "iDisplayLength": iDisplayLength,
        "iCookieDuration": 60 * 5,
        "bStateSave": bStateSave,
        "autoWidth": autoWidth,
        "bPaginate": bPaginate,
        "bFilter": bFilter,
        "responsive": responsive,
        "info": info,
        "scrollX": scrollX,
        "fnDrawCallback": function () {
            if (subtotalCalc) {
                appDatatableSubtotalCalc(table);
            }
            if (typeof reloadMasonry === "function") {
                reloadMasonry();
            }
            loadThemeV2Tooltips();
        },
        columnDefs: [
            {orderable: false, targets: notOrderableColumns}
        ],
        dom: dom,
        buttons: buttons,
        fixedHeader: {
            header: true,
            headerOffset: fixedHeaderOffset,
            footer: false
        }
    };

    if (typeof table.attr("dtScrollY") !== "undefined") {
        dataTableOptions["scrollY"] = table.attr("dtScrollY");
        dataTableOptions["fixedHeader"]["header"] = false;
        dataTableOptions["fixedHeader"]["footer"] = false;
    }

    if (typeof table.attr("dtDynamicColumns") !== "undefined" && table.attr("dtDynamicColumns") === "1") {
        var i = 0;
        var hiddenKeys = [];
        table.find("thead th").each(function () {
            if ($(this).attr("dtHidden") !== "undefined" && $(this).attr("dtHidden") === "1") {
                hiddenKeys.push(i);
            }
            i++;
        });
        if (hiddenKeys.length > 0) {
            dataTableOptions["columnDefs"].push({
                visible: false,
                targets: hiddenKeys
            });
        }
    }

    if (AppConfig["templateThemeVersion"] >= 2 && typeof table.attr("dtServerSideData") !== "undefined" && table.attr("dtServerSideData") === "1") {

        /*Serverside scroller*/
        if (typeof table.attr("dtScrollY") !== "undefined") {
            dataTableOptions["info"] = false;
            dataTableOptions["dom"] = "<'width-100 dt-header'f><'width-100'<'width-100'tS>>";
            dataTableOptions["scroller"] = {};
            dataTableOptions["oClasses"] = {"sInfo": "center dt-footer"};
        }

        dataTableOptions["lengthMenu"] = [[10, 20, 25, 50, 100, 200, 500], [10, 20, 25, 50, 100, 200, 500]];
        dataTableOptions["bProcessing"] = true;
        dataTableOptions["bServerSide"] = true;
        dataTableOptions["sAjaxSource"] = "/application/ajax/callClassMethod.php";
        dataTableOptions["fnServerData"] = function (sSource, aoData, fnCallback) {
            aoData.push({"name": "class", "value": table.attr("dtServerSideClass")});
            aoData.push({"name": "method", "value": table.attr("dtServerSideMethod")});
            var serverSideExtraParams = table.attr("dtServerSideExtraParams");
            if (typeof window[serverSideExtraParams] === "function") {
                aoData.push({"name": "extraParams", "value": window[serverSideExtraParams]()});
            }
            $.ajax({"type": "POST", "dataType": 'json', "url": sSource, "data": aoData, "success": fnCallback});
        };
        dataTableOptions["fnRowCallback"] = function (nRow, aData, iDisplayIndex, iDisplayIndexFull) {
            if (typeof aData["aaDataInfo"] !== "undefined") {
                var aaDataInfo = [];
                table.DataTable().columns().every(function () {
                    if (this.visible() && aData["aaDataInfo"][this.index()]) {
                        aaDataInfo.push(aData["aaDataInfo"][this.index()]);

                    }
                });
                $.each(aaDataInfo, function (k, v) {
                    if (typeof table.attr("dtScrollY") !== "undefined") {
                        v["style"] = v["style"] ? v["style"] + " white-space: normal;" : "white-space: normal;";
                    }
                    $.each(v, function (kV, vV) {
                        $('td:eq(' + k + ')', nRow).attr(kV, vV);
                    });
                });
            }
            var lastTd = $(nRow).find("td").last();
            lastTd.css({"width": "5px", "text-align": "right", "white-space": "nowrap"});
        };
    }

    if (table.attr("dtColumnFiltering") === "1" && table.attr("dtServerSideData") !== "1" && table.attr("dtDynamicColumns") !== "1") {
        dataTableOptions["bFilter"] = true;
        dataTableOptions["initComplete"] = function () {

            var dataTable = this.api();
            /*Metemos un TR encima de la cabecera para alojar los filtros*/
            $(table).find('thead:eq(0)').prepend($('<tr class="dt-column-filters-container"></tr>'));
            $(table).find('thead:eq(0) tr:eq(1) th').each(function (i) {
                $(table).find('thead:eq(0) tr:eq(0)').append($('<td/>').html($(this).html()));
            });

            dataTable.columns().every(function () {
                var column = this;
                var columnHeader = $(column.header());
                var columnHeaderText = columnHeader.text();
                var filterContainer = $(table).find('thead:eq(0) tr:eq(0) td:eq(' + column.index() + ')');
                filterContainer.html("");
                /*Solo aplican las columnas con texto en la cabecera (Para no filtrar por la columna de los botones)*/
                if (columnHeaderText !== "") {
                    var filterType = columnHeader.attr("dtColumnFilterType");
                    if (filterType === "select") {
                        var select = $('<select/>').css("width", "100%").on('change', function () {
                            var val = datatableProessSearchValue($.fn.dataTable.util.escapeRegex($(this).val()));
                            column.search(val ? '^' + val + '$' : '', true, false).draw();
                        });
                        select.append($('<option/>').val("").html("..."));
                        column.data().unique().sort().each(function (d, j) {
                            if (d !== "") {
                                var option = $('<option/>').val(d).html(d);
                                if (column.search() === "^" + datatableProessSearchValue($.fn.dataTable.util.escapeRegex(d)) + "$") {
                                    option.attr("selected", "selected");
                                }
                                select.append(option);
                            }
                        });
                        filterContainer.html(select);
                        if (column.search() !== "" && select.val() === "") {
                            select.trigger("change");
                        }
                    } else if (filterType !== "none") {
                        var input = $('<input/>').attr("type", "text").css("width", "100%").val(column.search()).on('keyup change', function () {
                            if (column.search() !== datatableProessSearchValue($(this).val())) {
                                column.search(datatableProessSearchValue($(this).val())).draw();
                            }
                        });
                        filterContainer.html(input);
                    }
                }
            });
        };
    }
    table.dataTable(dataTableOptions);
}

function appDatatableServerSide(table)
{
    if ($.fn.DataTable.isDataTable(table))
    {
        return false;
    }

    var arrDtOrder = ["0", "asc"];
    if (typeof table.attr("dtorder") !== "undefined")
    {
        arrDtOrder = table.attr("dtorder").split("-");
    }

    var orderLastColumn = true;
    var notOrderableColumns = [];
    if (typeof table.attr("dtorderLastColumn") === "undefined" || table.attr("dtorderLastColumn") !== "1")
    {
        orderLastColumn = false;
        notOrderableColumns.push(-1);
    }
    if (typeof table.attr("dtorderFirstColumn") !== "undefined" && table.attr("dtorderFirstColumn") === "0")
    {
        notOrderableColumns.push(0);
    }
    if (typeof table.attr("dtNotSortableColumns") !== "undefined" && table.attr("dtNotSortableColumns") !== "")
    {
        var dtNotSortableColumns = table.attr("dtNotSortableColumns").split(",");
        $.each(dtNotSortableColumns, function (k, v) {
            notOrderableColumns.push(v * 1);
        });
    }

    var dom = "<'width-100 dt-header'lf><'width-100'<'width-100 div-table-container'tr>><'width-100 dt-footer'ip>";

    table.dataTable({
        "aaSorting": [[arrDtOrder[0], arrDtOrder[1]]],
        "iCookieDuration": 60 * 5,
        "bStateSave": true,
        "autoWidth": false,
        "bProcessing": true,
        "bServerSide": true,
        "sAjaxSource": "/application/ajax/datatableServerSide.php",
        "fnServerData": function (sSource, aoData, fnCallback) {
            aoData.push({
                "name": "callerClass",
                "value": table.attr("callerClass")
            });
            aoData.push({
                "name": "objectId",
                "value": table.attr("objectId")
            });
            aoData.push({
                "name": "method",
                "value": table.attr("method")
            });
            $.ajax({
                "type": "GET",
                "dataType": 'json',
                "url": sSource,
                "data": aoData,
                "success": fnCallback
            });
        },
        "fnRowCallback": function (nRow, aData, iDisplayIndex, iDisplayIndexFull) {
            if (orderLastColumn === false) {
                var lastTd = $(nRow).find("td").last();
                lastTd.css({"width": "5px", "text-align": "right", "white-space": "nowrap"});
            }
        },
        dom: dom,
        columnDefs: [
            {orderable: false, targets: notOrderableColumns}
        ]
    });
}

function appDatatableScrollerServerSide(table)
{
    var arrDtOrder = ["0", "asc"];
    if (typeof table.attr("dtorder") != "undefined")
    {
        arrDtOrder = table.attr("dtorder").split("-");
    }
    var scrollY = 400;
    if (typeof table.attr("scrollY") != "undefined")
    {
        if (table.attr("scrollY") === "until-page-bottom") {
            scrollY = ($(window).height() - table.offset().top - table.find("thead").height() - 30);
        } else {
            scrollY = parseInt(table.attr("scrollY"));
        }
    }

    var orderLastColumn = false;
    if (typeof table.attr("dtorderLastColumn") != "undefined" && table.attr("dtorderLastColumn") === "1")
    {
        orderLastColumn = true;
    }

    var bStateSave = false;
    if (typeof table.attr("dtbStateSave") != "undefined" && table.attr("dtbStateSave") === "1")
    {
        bStateSave = true;
    }

    var info = true;
    if (typeof table.attr("dtInfo") !== "undefined" && table.attr("dtInfo") === "0")
    {
        info = false;
    }

    table.DataTable({
        "aaSorting": [[arrDtOrder[0], arrDtOrder[1]]],
        "iCookieDuration": 60 * 5,
        "bStateSave": bStateSave,
        "autoWidth": true,
        "serverSide": true,
        "ordering": true,
        "info": info,
        "sAjaxSource": "/application/ajax/datatableServerSide.php",
        "fnServerData": function (sSource, aoData, fnCallback) {
            aoData.push({
                "name": "callerClass",
                "value": table.attr("callerClass")
            });
            aoData.push({
                "name": "objectId",
                "value": table.attr("objectId")
            });
            aoData.push({
                "name": "method",
                "value": table.attr("method")
            });
            aoData.push({
                "name": "TYPE",
                "value": table.attr("type")
            });
            $.ajax({
                "type": "GET",
                "dataType": 'json',
                "url": sSource,
                "data": aoData,
                "success": fnCallback
            });
        },
        dom: "rtiS",
        scrollY: scrollY,
        scroller: {
            loadingIndicator: true
        },
        "oClasses": {
            "sInfo": "center dt-footer"
        },
        "fnCreatedRow": function (nRow, aData, iDataIndex) {
            if (table.attr("callerClass") === "Customer" || table.attr("callerClass") === "Provider")
            {
                $(nRow).attr('id', aData[(aData.length - 3)]);
                if (aData[(aData.length - 1)] == "1")
                {
                    $(nRow).css('text-decoration', "line-through");
                }
                if (aData[(aData.length - 2)] == "1")
                {
                    $(nRow).css('color', "red");
                }
            } else
            {
                $(nRow).attr('id', aData[(aData.length - 1)]);
            }
        },
        "fnRowCallback": function (nRow, aData, iDisplayIndex, iDisplayIndexFull) {
            var contentWidth = table.width();
            var nTds = $(nRow).find("td").length;
            var maxWidth = (contentWidth / nTds).toFixed(0);
            $(nRow).find("td").css({"max-width": maxWidth + "px", "overflow": "hidden", "text-overflow": "ellipsis"});
        },
        columnDefs: [{orderable: orderLastColumn, targets: -1}]
    });
}

function datatableProessSearchString(data)
{
    var ret = !data ?
            '' :
            typeof data === 'string' ?
            data
            .toLowerCase()
            .replace(/[ñ]/g, 'n')
            .replace(/[áâàä]/g, 'a')
            .replace(/[éêèë]/g, 'e')
            .replace(/[íîìï]/g, 'i')
            .replace(/[óôòö]/g, 'o')
            .replace(/[úûùü]/g, 'u') :
            data;
    return ret;
}

function datatableProessSearchValue(data)
{
    return datatableProessSearchString(data);
}

function appDatatableSubtotalCalc(table)
{
    var tableId = table.attr("id");

    /*Borramos los subtotales actuales ya que les vamos a regenerar si procede*/
    var newTrId = tableId + '_appDatatableSubtotals';
    var newTrPercentageId = tableId + '_appDatatableSubtotalsPercentage';
    $('#' + newTrId).remove();
    $('#' + newTrPercentageId).remove();

    /*Solo aplica si no estamos mostrando todos los registros*/
    var info = table.DataTable().page.info();
    var totalRecords = table.DataTable().page.info().recordsTotal;
    var displayedRecords = info.end - info.start;
    if (totalRecords === displayedRecords || displayedRecords === 0) {
        return false;
    }

    /*Miramos a ver si tenemos tbody y foother*/
    var tbody = table.find("tbody");
    var tfoot = table.find("tfoot");
    if (!tbody.html() || !tfoot.html() || tfoot.find("tr").length !== 1) {
        return false;
    }

    /*Generamos la fila de subtotales y porcentaje y obtenemos las columnas a sumar*/
    var i = 0;
    var first = true;
    var numericCols = {
    };
    var tr = tfoot.find("tr");
    var newTr = $('<tr id="' + newTrId + '">');
    var newTrPercentage = $('<tr id="' + newTrPercentageId + '">');
    tr.find("th").each(function (k, v) {
        var colspan = $(v).attr("colspan");
        if (colspan > 1) {
            i = i + (colspan - 1);
        }
        var style = 'text-align:right;';

        var newTh = $('<th id="' + newTrId + '_' + i + '" colspan="' + colspan + '" style="' + style + '">');
        var newThPercentage = $('<th id="' + newTrPercentageId + '_' + i + '" colspan="' + colspan + '" style="' + style + '">');

        if (first) {
            newTh.html('Subtotal');
            newThPercentage.html('%');
            first = false;
        } else if ($(v).html() !== "") {
            var floatValue = appParseFloat($(v).html());
            if (!isNaN(floatValue)) {
                if (!numericCols[i]) {
                    numericCols[i] = {
                        total: 0,
                        subtotal: 0
                    };
                }
                numericCols[i]["total"] += floatValue;
            }
        }
        newTr.append(newTh);
        newTrPercentage.append(newThPercentage);
        i = i + 1;
    });

    /*recorremos las filas de la tabla para sumar sus valores*/
    tbody.find("tr").each(function () {
        i = 0;
        $(this).find("td").each(function () {
            if (numericCols[i] && $(this).html() !== "") {
                var value = appParseFloat($(this).html());
                if (!isNaN(value)) {
                    numericCols[i]["subtotal"] += value;
                }
            }
            i = i + 1;
        });
    });

    tfoot.prepend(newTrPercentage);
    tfoot.prepend(newTr);

    /*Recorremos las filas para poner los subtotales y calcular los porcentajes*/
    for (var j = 0; j < i; j++) {
        if (numericCols[j]) {

            var targetId = newTrId + '_' + j;
            $("#" + targetId).html(appNumberFormat(numericCols[j]["subtotal"]));

            targetId = newTrPercentageId + '_' + j;
            $("#" + targetId).html(appNumberFormat(100 * (numericCols[j]["subtotal"] / numericCols[j]["total"])));
        }
    }

    /*Si solo hay una fila en la tabla solo muestro el porcentaje*/
    if (displayedRecords === 1) {
        $('#' + newTrId).remove();
    }

    return true;
}

function toggleDatatableColumnVisibility(tableId, columnId)
{
    var table = $('#' + tableId).DataTable();
    var column = table.column(columnId);
    if (column.visible()) {
        column.visible(false);
        $('#datatableColumnVisibilityDiv__' + tableId + '__' + columnId).removeClass('active');
    } else {
        column.visible(true);
        $('#datatableColumnVisibilityDiv__' + tableId + '__' + columnId).addClass('active');
    }
    table.draw();

    return true;
}

$.fn.dataTable.ext.buttons.wolfDynamicColumns = {
    text: '<i class="fa fa-list-ul"></i>',
    action: function (e, dt, node, config) {
        var tableId = dt.table().node().id;
        var columns = '<div class="row">';
        dt.columns().every(function () {
            var validColumn = true;
            var columnText = this.header().innerHTML;
            if ($.trim(columnText) === "" || columnText.indexOf('class="btn') !== -1) {
                validColumn = false;
            }

            if (validColumn) {
                var columnId = this.index();
                var divId = 'datatableColumnVisibilityDiv__' + tableId + '__' + columnId;
                var active = 'active';
                if (!this.visible()) {
                    active = '';
                }

                columns = columns + '<div id="' + divId + '" onclick="toggleDatatableColumnVisibility(\'' + tableId + '\',\'' + columnId + '\');" class="col-sm-3 col-xs-4 wolf-dt-column-visibility-div ' + active + '">' + columnText + '</div>';
            }
        });
        columns = columns + '</div>';
        showWolfWarning(columns, '&nbsp;<i class="fa fa-list-ul"></i> Columnas disponibles', "panel-default");
    }
};

$.fn.DataTable.ext.type.search.string = function (data) {
    return datatableProessSearchString(data);
};

$.fn.dataTableExt.aTypes.unshift(
        function (sData)
        {
            if (!sData || typeof sData !== "string") {
                return null;
            }

            if (sData.match(/^(0[1-9]|[12][0-9]|3[01])\/(0[1-9]|1[012])\/(19|20|21)\d\d$/))
            {
                return 'date-CRM';
            }
            if (sData.match(/^([1-9]|([012][0-9])|(3[01]))\/([0]{0,1}[1-9]|1[012])\/\d\d\d\d [012]{0,1}[0-9]:[0-6][0-9]$/))
            {
                return 'date-CRM';
            }
            if (sData.match(/^([1-9]|([012][0-9])|(3[01]))\/([0]{0,1}[1-9]|1[012])\/\d\d\d\d [012]{0,1}[0-9]:[0-6][0-9]:[0-6][0-9]$/))
            {
                return 'date-CRM';
            }
            if (sData.match(/^(<select)(.*)(<\/select>)$/))
            {
                return 'html-select';
            }
            if (sData.match(/^(<input)(.*)(>)$/))
            {
                return 'html-input';
            }

            var sValidChars = "0123456789,.";
            var Char;
            var iStart = 0;

            if (sData.length > 0 && sData.charAt(0) === '-') {
                iStart = 1;
            }

            for (var i = iStart; i < sData.length; i++)
            {
                Char = sData.charAt(i);
                if (sValidChars.indexOf(Char) == -1)
                {
                    return null;
                }
            }
            return 'numeric-CRM';
        }
);

$.fn.dataTableExt.aTypes.push(
        function (sData)
        {
            if (!sData || typeof sData !== "string") {
                return null;
            }

            if (sData.match(/^(0[1-9]|[12][0-9]|3[01])\/(0[1-9]|1[012])\/(19|20|21)\d\d$/))
            {
                return 'date-CRM';
            }
            if (sData.match(/^([1-9]|([012][0-9])|(3[01]))\/([0]{0,1}[1-9]|1[012])\/\d\d\d\d [012]{0,1}[0-9]:[0-6][0-9]$/))
            {
                return 'date-CRM';
            }
            if (sData.match(/^([1-9]|([012][0-9])|(3[01]))\/([0]{0,1}[1-9]|1[012])\/\d\d\d\d [012]{0,1}[0-9]:[0-6][0-9]:[0-6][0-9]$/))
            {
                return 'date-CRM';
            }

            var sValidChars = "0123456789,.";
            var Char;
            var iStart = 0;

            if (sData.length > 0 && sData.charAt(0) === '-') {
                iStart = 1;
            }

            for (var i = iStart; i < sData.length; i++)
            {
                Char = sData.charAt(i);
                if (sValidChars.indexOf(Char) == -1)
                {
                    return null;
                }
            }
            return 'numeric-CRM';

        }
);

$.fn.dataTableExt.oSort['date-CRM-asc'] = function (a, b) {
    if (trim(a) != '') {
        var frDatea = trim(a).split(' ');
        if (typeof frDatea[1] != "undefined")
            var frTimea = frDatea[1].split(':');
        else
            var frTimea = [0, 0, 0];
        var frDatea2 = frDatea[0].split('/');
        if (typeof frTimea[2] == "undefined")
            frTimea[2] = 0;
        var x = (frDatea2[2] + frDatea2[1] + frDatea2[0] + frTimea[0] + frTimea[1] + frTimea[2]) * 1;
    } else {
        var x = 10000000000000; // = l'an 1000 ...
    }

    if (trim(b) != '') {
        var frDateb = trim(b).split(' ');
        if (typeof frDateb[1] != "undefined")
            var frTimeb = frDateb[1].split(':');
        else
            var frTimeb = [0, 0, 0];
        frDateb = frDateb[0].split('/');
        if (typeof frTimeb[2] == "undefined")
            frTimeb[2] = 0;
        var y = (frDateb[2] + frDateb[1] + frDateb[0] + frTimeb[0] + frTimeb[1] + frTimeb[2]) * 1;
    } else {
        var y = 10000000000000;
    }
    var z = ((x < y) ? -1 : ((x > y) ? 1 : 0));
    return z;
};

$.fn.dataTableExt.oSort['date-CRM-desc'] = function (a, b) {
    if (trim(a) != '') {
        var frDatea = trim(a).split(' ');
        if (typeof frDatea[1] != "undefined")
            var frTimea = frDatea[1].split(':');
        else
            var frTimea = [0, 0, 0];
        var frDatea2 = frDatea[0].split('/');
        if (typeof frTimea[2] == "undefined")
            frTimea[2] = 0;
        var x = (frDatea2[2] + frDatea2[1] + frDatea2[0] + frTimea[0] + frTimea[1] + frTimea[2]) * 1;
    } else {
        var x = 10000000000000;
    }

    if (trim(b) != '') {
        var frDateb = trim(b).split(' ');
        if (typeof frDateb[1] != "undefined")
            var frTimeb = frDateb[1].split(':');
        else
            var frTimeb = [0, 0, 0];
        frDateb = frDateb[0].split('/');
        if (typeof frTimeb[2] == "undefined")
            frTimeb[2] = 0;
        var y = (frDateb[2] + frDateb[1] + frDateb[0] + frTimeb[0] + frTimeb[1] + frTimeb[2]) * 1;
    } else {
        var y = 10000000000000;
    }
    var z = ((x < y) ? 1 : ((x > y) ? -1 : 0));
    return z;
};

$.fn.dataTableExt.oSort["numeric-CRM-asc"] = function (a1, b1) {
    a = a1.replace(/[^\d|\-]/g, '');
    b = b1.replace(/[^\d|\-]/g, '');

    if (a.indexOf('/') >= 0)
        a = eval(a);
    if (b.indexOf('/') >= 0)
        b = eval(b);

    var x = (a == "-") ? 0 : a;
    var y = (b == "-") ? 0 : b;
    x = parseFloat(x);
    y = parseFloat(y);
    return ((x < y) ? -1 : ((x > y) ? 1 : 0));
};

$.fn.dataTableExt.oSort["numeric-CRM-desc"] = function (a1, b1) {
    a = a1.replace(/[^\d|\-]/g, '');
    b = b1.replace(/[^\d|\-]/g, '');

    if (a.indexOf('/') >= 0)
        a = eval(a);
    if (b.indexOf('/') >= 0)
        b = eval(b);

    var x = (a == "-") ? 0 : a;
    var y = (b == "-") ? 0 : b;
    x = parseFloat(x);
    y = parseFloat(y);
    return ((x < y) ? 1 : ((x > y) ? -1 : 0));
};

$.fn.dataTableExt.ofnSearch['html-select'] = function (value) {
    return $("option:selected", value).text();
};

$.fn.dataTableExt.oSort["html-select-asc"] = function (a1, b1) {
    var a = $("option:selected", a1).text();
    var b = $("option:selected", b1).text();
    return ((a < b) ? -1 : ((a > b) ? 1 : 0));
};

$.fn.dataTableExt.oSort["html-select-desc"] = function (a1, b1) {
    var a = $("option:selected", a1).text();
    var b = $("option:selected", b1).text();
    return ((a < b) ? 1 : ((a > b) ? -1 : 0));
};

$.fn.dataTableExt.oSort["html-input-asc"] = function (a1, b1) {
    var a = $(a1).val();
    if ($.isNumeric(a)) {
        a = a * 1;
    }
    var b = $(b1).val();
    if ($.isNumeric(b)) {
        b = b * 1;
    }
    return ((a < b) ? -1 : ((a > b) ? 1 : 0));
};

$.fn.dataTableExt.oSort["html-input-desc"] = function (a1, b1) {
    var a = $(a1).val();
    if ($.isNumeric(a)) {
        a = a * 1;
    }
    var b = $(b1).val();
    if ($.isNumeric(b)) {
        b = b * 1;
    }
    return ((a < b) ? 1 : ((a > b) ? -1 : 0));
};

$.extend(true, $.fn.dataTable.defaults, {
    "language": {
        "processing": "Procesando...",
        "sLoadingRecords": "Procesando...",
        "lengthMenu": "Mostrar _MENU_ registros por página",
        "zeroRecords": "No se encontraron resultados con los filtros aplicados",
        "emptyTable": "No se encontraron resultados con los filtros aplicados",
        "infoEmpty": "Mostrando desde 0 hasta 0 de 0 registros",
        "infoFiltered": "(filtrado de _MAX_ registros)",
        "search": "Filtrar:",
        "paginate": {
            "first": "Primero",
            "last": "última",
            "next": "Siguiente",
            "previous": "Anterior"
        },
        "buttons": {
            "excel": '<i class="fa fa-download"></i>'
        },
        "info": "Mostrando desde _START_ hasta _END_ de _TOTAL_ registros"
    }
});