var loadParameters = {
    cmd: 'getEvents',
    exclusive: true,
    diaryView: diaryConfig.diaryView,
    diaryDate: diaryConfig.diaryDate.getTime() / 1000
};
var fullCalendarHeight = 1200;
var fullCalendarHeaderLeft = 'prev,next today';
var fullCalendarHeaderCenter = 'title';
var fullCalendarHeaderRight = 'month,agendaWeek,listWeek,agendaDay,listDay';
var diaryUrl = '/diary/index.php';
var clickUrl = '/actions/object.php?ID=';
$(function () {

    $(".diaryFilter").each(function () {
        loadParameters[$(this).attr("name")] = $(this).val();
    });

    $("#diaryManualDate").change(function () {
        var time = $(this).val().split("/");
        var date = new Date(time[2] + "-" + time[1] + "-" + time[0]);
        $('#diary').fullCalendar('gotoDate', date);
    });
    $('#todayButton').click(function () {
        $('#diary').fullCalendar('today');
        $("#diaryManualDate").val(getActualDateToInput());
    });
    $('#btnNext').click(function () {
        $('#diary').fullCalendar('next');
        $("#diaryManualDate").val(getActualDateToInput());
    });
    $('#btnPrev').click(function () {
        $('#diary').fullCalendar('prev');
        $("#diaryManualDate").val(getActualDateToInput());
    });

    $('#diary').fullCalendar({
        defaultView: diaryConfig.diaryView,
        defaultDate: moment.utc(diaryConfig.diaryDate),
        minTime: diaryConfig.minTime + ":00:00",
        maxTime: diaryConfig.maxTime + ":00:00",
        aspectRatio: 0.7,
        height: 'auto',
        allDayText: 'Todo el d\u00EDa',
        eventLimitText: 'más',
        weekNumberTitle: '',
        slotLabelFormat: 'HH:mm',
        dayPopoverFormat: 'dddd, D MMM, YYYY',
        listDayFormat: 'dddd, D MMM',
        listDayAltFormat: '',
        themeSystem: 'bootstrap3',
        noEventsMessage: "No se encontraron resultados con los filtros aplicados",
        // time formats
        views: {
            month: {
                eventLimit: diaryConfig.eventLimit,
                displayEventEnd: false,
                titleFormat: 'MMMM YYYY',
                columnFormat: 'ddd',
                timeFormat: 'HH:mm '/*,
                 weekNumbers: true*/
            },
            week: {
                titleFormat: 'D MMM YYYY',
                columnFormat: 'ddd D/M',
                timeFormat: 'HH:mm '
            },
            day: {
                titleFormat: 'dddd, D MMM, YYYY',
                columnFormat: 'dddd D/M',
                timeFormat: 'HH:mm '
            }
        },
        isRTL: false,
        firstDay: 1,
        monthNames: ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'],
        monthNamesShort: ['Ene', 'Feb', 'Mar', 'Abr', 'May', 'Jun', 'Jul', 'Ago', 'Sep', 'Oct', 'Nov', 'Dic'],
        dayNames: ['Domingo', 'Lunes', 'Martes', 'Mi\u00E9rcoles', 'Jueves', 'Viernes', 'S\u00E1bado'],
        dayNamesShort: ['Do', 'Lu', 'Ma', 'Mi', 'Ju', 'Vi', 'Sa'],
        buttonText: {
            today: 'hoy',
            month: 'mes',
            week: 'semana',
            day: 'd\u00EDa',
            listWeek: 'lista',
            listDay: 'lista'
        },
        header: {
            left: fullCalendarHeaderLeft,
            center: fullCalendarHeaderCenter,
            right: fullCalendarHeaderRight
        },
        editable: false,
        eventSources: gCalEvenSources(),
        loading: function (isLoading, view) {
            if (isLoading) {
                blockFullcalendar();
            } else {
                unblockFullcalendar();
            }
        },
        eventClick: function (calEvent, jsEvent, view) {
            if ((calEvent.clickEnabled === true || calEvent.editable !== false || calEvent.className == "google-event" || calEvent.class == "ical-event") && typeof (calEvent.objectUrl) != "undefined")
            {
                openWindow(calEvent.objectUrl);
            }

        },
        dayClick: function (date, jsEvent, view) {

            if (AppConfig["readOnlyUser"]) {
                return false;
            }

            var dateString = date.format("YYYY-MM-DD");
            var timeString = date.format("HH:mm");

            var now = new Date();
            var timeNow = pad(now.getHours(), 2) + ":" + pad(now.getMinutes(), 2);
            if (timeString === "00:00") {
                openWindow(clickUrl + "&START_DATE=" + dateString + "T" + timeNow);
            } else {
                openWindow(clickUrl + "&START_DATE=" + dateString + "T" + timeString);
            }
        },
        viewRender: function (view, element) {

            if (view.name === "month") {
                $('#diary').fullCalendar('option', 'height', "auto");
                $('#diary').fullCalendar('option', 'contentHeight', 1);
            } else if (view.name !== "agendaDay") {
                var topHeight = 140;
                if (AppConfig["templateThemeVersion"] >= 2) {
                    var topHeight = 120;
                }
                $('#diary').fullCalendar('option', 'height', $(window).height() - topHeight);
                $('#diary').fullCalendar('option', 'contentHeight', "auto");
            } else {
                $('#diary').fullCalendar('option', 'height', 'auto');
                $('#diary').fullCalendar('option', 'contentHeight', "auto");
            }

            updateAjaxInitialized = true;
            $.post(diaryUrl, {
                cmd: "updateView",
                diaryView: view.name,
                diaryDate: view.intervalStart.format("X")
            }).complete(function () {
                updateAjaxInitialized = false;
            });
        },
        eventAfterAllRender: function (view) {
            if (view.name === "month" && $(".multi-line-fc-content").length) {
                $("div.fc-content").addClass("multi-line-fc-content");
            }
            loadSavedDiaryScroll();
        },
        eventResize: function (event, delta, revertFunc, jsEvent, ui, view) {
            updateEvent(event, revertFunc, view);
        },
        eventDrop: function (event, delta, revertFunc, jsEvent, ui, view) {
            updateEvent(event, revertFunc, view);
        },
        eventRender: function (event, element, view) {
            element.attr("title", event.title);
            var titleClass = ".fc-title";
            if (element.find("td.fc-list-item-title").length) {
                titleClass = "td.fc-list-item-title";
            }

            var fcTitle = element.find(titleClass);
            if (event.custom_icon) {
                fcTitle.prepend(event.custom_icon);
            } else {
                if (event.creator !== event.user)
                    fcTitle.prepend(renderIcon("fa fa-sign-in", "float:left;color:black;margin-right:2px;", event.creatorName));
                if (event.finished)
                    fcTitle.prepend(renderIcon("fa fa-check", "float:left;color:black;margin-right:2px;"));
            }

            /* Nuevo icono para diferenciar tipo de cliente */
            if (AppConfig["templateThemeVersion"] >= 3) {
                var iconCircleCalendar = '<span class="fc-item-fa-stack-icon fa-stack" style="color:' + event["color"] + ';"><span class="fa fa-circle-o fa-stack-2x"></span>' + (event["customerPrefixChar"] ? '<span class="fa-stack-1x bold">' + event["customerPrefixChar"] + '</span>' : '') + '</span>';
            }

            if (AppConfig["templateThemeVersion"] >= 2 && view["name"].indexOf("list") === -1) {
                var fcContent = fcTitle.parent();
                if (AppConfig["templateThemeVersion"] >= 3) {
                    fcTitle.before(iconCircleCalendar);
                } else {
                    fcTitle.prepend(renderIcon("fa fa-circle", "color:" + event["color"] + ";float:left;margin-right:2px;"));
                }
                if (event["class"] === "Action") {
                    if (event["background-color"] != '' && event["background-color"] != '#') {
                        fcContent.parent().css("background-color", event["background-color"]);
                    } else {
                        fcContent.parent().css("background-color", "#e6e6e6");
                    }
                } else {
                    fcContent.parent().css("background-color", "#d8e3e8");
                }
                fcContent.parent().css("border-color", "transparent");
                if (!fcContent.parent().css("color") || fcContent.parent().css("color") === "rgb(0, 0, 0)" || fcContent.parent().css("color") === "rgb(255, 255, 255)") {
                    fcContent.parent().css("color", "#333");
                }
                if (view["name"] === "month") {
                    fcContent.find(".fc-time").css("float", "right");
                }
            } else if (AppConfig["templateThemeVersion"] >= 3 && view["name"].indexOf("list") === 0 && element.find('span.fc-event-dot').length) {
                element.find('span.fc-event-dot').replaceWith(iconCircleCalendar);
            }

            if (view.name === "month" && event.title.indexOf("\n") !== -1) {
                $(element).find("div.fc-content").addClass("multi-line-fc-content");
            }
        }
    });

    $(window).scroll(function () {
        saveDiaryCurrentScroll();
        checkfixedFcHead();
    });

    function blockFullcalendar() {
        $('#diary').block(blockMessage("Cargando..."));
    }

    function unblockFullcalendar() {
        $('#diary').unblock();
        if (typeof reloadMasonry === "function") {
            reloadMasonry();
        }
    }

    function blockMessage(message) {
        var blockMessage = {
            message: '<img src="/images/loading.gif" />',
            overlayCSS: {
                backgroundColor: '#000'
            },
            fadein: 1000,
            centerX: true,
            centerY: false,
            css: {
                padding: "10px"
            }
        };
        blockMessage.message = blockMessage.message + message;
        return blockMessage;
    }

    function gCalEvenSources() {
        var sources = [];
        sources[0] = {
            url: diaryUrl,
            data: loadParameters,
            timeout: 10000,
            error: function () {
                alert('Se produjo un error recuperando los eventos');
            }
        };
        return sources;
    }

    function updateEvent(event, revertFunc, view) {

        if (event.editable === false || event.allDay !== event.allDayInitial)
        {
            alert('Action not allowed.');
            revertFunc();
            return false;
        }

        var dates = processFullCalendarDates(event);

        var sendingObject = {
            unixstart: dates["startTimestamp"],
            class: event['class'],
            ID: event['ID'],
            allDay: event['allDay']
        };
        if (dates["endTimestamp"] !== "") {
            sendingObject.unixend = dates["endTimestamp"];
        }
        blockFullcalendar();
        $(window).on("beforeunload", function () {
            return 'Los \u00faltimos cambios no se han guardado. ¿Seguro que quiere salir?';
        });
        $.ajax({
            type: "POST",
            url: diaryUrl,
            data: {
                cmd: "updateEvent",
                "event": sendingObject
            },
            global: false,
            dataType: "json",
            success: updateSuccess,
            complete: updateCompleted,
            timeout: 10000,
            error: function () {
                $('#messages').css('color', 'red').text('Error de conexi\u00F3n: no se pudieron guardar los cambios. Vuelva a intentarlo.');
                revertFunc();
            }
        });

        function updateSuccess(data) {
            if (data["result"] <= '0') {
                alert('Error al guardar los cambios: ' + data["response"]);
                revertFunc();
            }
            $('#messages').text('');
        }

        function updateCompleted() {
            $(window).off("beforeunload");
            unblockFullcalendar();
            updateAjaxInitialized = false;
        }
    }

    function processFullCalendarDates(event) {

        var ret = {
            "start": "",
            "startTimestamp": "",
            "end": "",
            "endTimestamp": ""
        };

        var startSplit = event.start.format("YYYY-MM-DD HH:mm:ss").split(" ");
        if (startSplit[1] === "00:00:00" && typeof event.start._i === "string") {
            var iSplit = event.start._i.split(" ");
            if (iSplit[1]) {
                startSplit[1] = iSplit[1];
            }
        }
        var momentStart = moment(startSplit[0] + " " + startSplit[1]);
        ret["start"] = momentStart.format("YYYY-MM-DD HH:mm:ss");
        ret["startTimestamp"] = momentStart.format("X");

        if (event.end) {
            var endSplit = event.end.format("YYYY-MM-DD HH:mm:ss").split(" ");
            if (endSplit[1] === "00:00:00" && typeof event.end._i === "string") {
                var iSplit = event.end._i.split(" ");
                if (iSplit[1]) {
                    endSplit[1] = iSplit[1];
                }
            }
            var momentEnd = moment(endSplit[0] + " " + endSplit[1]);
            if (event.allDay && startSplit[0] !== endSplit[0]) {
                momentEnd.subtract(1, 'd');
            }
            ret["end"] = momentEnd.format("YYYY-MM-DD HH:mm:ss");
            ret["endTimestamp"] = momentEnd.format("X");
        }

        return ret;
    }

    function getActualDateToInput() {
        var date = new Date($('#diary').fullCalendar('getDate'));
        var dateString = pad(date.getDate(), 2) + "/" + pad(date.getMonth() + 1, 2) + "/" + date.getFullYear();
        return dateString;
    }

    function checkfixedFcHead() {

        if (!$(".fc-month-view").length) {
            return false;
        }

        var referenceElement = $(".fc-toolbar.fc-header-toolbar");
        var fcCenter = referenceElement.find(".fc-center, .fc-left");
        var fcRow = $(".fc-head-container>div.fc-row");

        var offset = 0;
        if ($(".navbar-fixed-top").length) {
            offset = $(".navbar-fixed-top").height() + 5;
        }

        var docViewTop = $(window).scrollTop() + offset;
        var docViewBottom = docViewTop + $(window).height();

        var elemTop = referenceElement.offset().top;
        var elemBottom = elemTop + referenceElement.height();

        if ((elemBottom <= docViewBottom) && (elemTop >= docViewTop)) {
            fcCenter.removeClass("fc-fixed-head-container").removeClass("width-100").removeClass("padding").removeClass("terciary-color").css("top", "initial");
            fcRow.removeClass("fc-fixed-head-container").css("top", "initial");
            return false;
        } else {
            fcCenter.addClass("fc-fixed-head-container").addClass("width-100").addClass("padding").addClass("terciary-color").css("top", offset + "px");
            fcRow.addClass("fc-fixed-head-container").css("top", (offset + fcCenter.height() + 5) + "px");
            return true;
        }
    }

    function saveDiaryCurrentScroll() {
        if (!$(".fc-month-view").length && !$(".fc-list-view").length) {
            return false;
        }
        setLocalStorageItem("diaryCurrentScroll", $(window).scrollTop());
        return true;
    }

    function loadSavedDiaryScroll() {
        if (!$(".fc-month-view").length && !$(".fc-list-view").length) {
            return false;
        }
        var savedScroll = getLocalStorageItem("diaryCurrentScroll");
        if (!savedScroll || savedScroll === 0) {
            return false;
        }
        $(window).scrollTop(savedScroll);
        return true;
    }

    $(".diaryFilter").change(function () {
        $(".diaryFilter").each(function () {
            loadParameters[$(this).attr("name")] = $(this).val();
        });
        $('#diary').fullCalendar('refetchEvents');
    });
});
