jQuery.fn.swapFrontItems = function (b) {
    b = jQuery(b)[0];
    var a = this[0];
    var t = a.parentNode.insertBefore(document.createTextNode(''), a);
    b.parentNode.insertBefore(a, b);
    t.parentNode.insertBefore(b, t);
    t.parentNode.removeChild(t);
    var data = {
        "class": "Front",
        "method": "swapFrontItems",
        "item1": $(a).attr("id"),
        "item2": $(b).attr("id")
    };
    callClassMethod(data, true);
    reloadMasonry();
    return this;
};

$(function () {
    initFrontPanels();
});

function initFrontPanels() {
    if ($('.grid').length) {
        $('.grid').masonry({
            itemSelector: '.grid-item',
            columnWidth: function (containerWidth) {
                return containerWidth / 2;
            }
        });
    }

    $(".dragdrop-front").each(function () {
        var button = '<i class="dragdrop-front-handle fa fa-arrows pointer no-print" style="position:absolute;top:10px;right:10px;" title="Move me"></i>';
        $(this).append(button);
    });

    $(".dragdrop-front").draggable({
        revert: false, helper: "clone", handle: ".dragdrop-front-handle"});

    $(".dragdrop-front").droppable({
        accept: ".dragdrop-front",
        activeClass: "ui-state-hover",
        hoverClass: "ui-state-active",
        drop: function (event, ui) {
            var draggable = ui.draggable;
            var droppable = $(this);
            draggable.swapFrontItems(droppable);
        }
    });

    $(".wolf-front-panel>.panel-heading").each(function () {
        var iClasses = "fa fa-angle-double-right";
        if (AppConfig["templateThemeVersion"] > 10) {
            var iClasses = "fa fa-chevron-down pointer";
        }
        var button = '<i class="collapse-front-handle margin-right ' + iClasses + '"></i>';
        $(this).prepend(button);
    });

    $(".form-group-container.form-group-collapsible .form-group-title").click(function () {
        reloadMasonry();
    });

    if (AppConfig["templateThemeVersion"] > 10) {
        $('.collapse-front-handle').on('click', function (e) {
            var $this = $(this);
            var container = $this.parent().parent().parent();
            var containerId = container.attr('id');
            var currentStatus = getLocalStorageItem(containerId);
            var panelBody = $this.parent().parent().find('.panel-body');
            if (currentStatus !== 'panel-collapsed') {
                setLocalStorageItem(containerId, 'panel-collapsed');
                panelBody.slideUp("fast", function () {
                    reloadMasonry();
                    $this.removeClass('fa-chevron-down').addClass('fa-chevron-right');
                });
            } else {
                setLocalStorageItem(containerId, '');
                panelBody.slideDown("fast", function () {
                    reloadMasonry();
                    $this.removeClass('fa-chevron-right').addClass('fa-chevron-down');
                    $.each(EchartsCRMV3, function (k, v) {
                        if (panelBody.find("div#" + k).length) {
                            v.resize();
                        }
                    });
                });
            }
        });
        initCollapsedPannels();
        initCounters();
    }
}

function initCollapsedPannels() {
    $(".front-item-container").each(function () {
        var containerId = $(this).attr('id');
        var panelBody = $(this).find(".panel-body");
        var handle = $(this).find(".collapse-front-handle");
        if (panelBody.length) {
            var currentStatus = getLocalStorageItem(containerId);
            if (currentStatus === 'panel-collapsed') {
                panelBody.hide();
                handle.removeClass('fa-chevron-down').addClass('fa-chevron-right');
                reloadMasonry();
            }
        }
    });
}

function reloadMasonry() {
    $(".panel-body").trigger('resize');
    if ($('.masonry')[0]) {
        $('.grid').masonry('reload');
    }
}

function initCounters() {
    $('.int-counter').each(function () {
        var initialvalue = appParseFloat($(this).text());
        if ($.isNumeric(initialvalue)) {
            $(this).prop('Counter', 0).animate({
                Counter: initialvalue
            }, {
                duration: 1000,
                easing: 'swing',
                step: function (now) {
                    $(this).text(numberFormat(now, 0));
                }
            });
        }
    });
}

function reloadFrontItem(key, extraParams) {
    var containerId = "#front_item__" + key;
    var container = $(containerId).find(".wolf-front-panel-content").first();

    if (!container.length) {
        return false;
    }
    container.html('<div class="width-100 center padding"><img src="/images/loading.gif"/></div>');
    var data = "class=Front&method=ajaxRenderItem&itemKey=" + key + "";
    if (typeof extraParams !== "undefined") {
        data = data + "&" + extraParams;
    }
    callClassMethod(data, true, function (html) {
        container.html(html);
        $(containerId + ' .data-table').each(function () {
            appDatatable($(this));
        });
        reloadMasonry();
    });
    return true;
}