$(function ()
{
    if ($("#side-menu-toggle").length) {
        $("#side-menu-toggle").click(function (e) {
            e.preventDefault();
            toggleSideMenu();
        });
        if (getLocalStorageItem("side-menu-size") === "collapsed") {
            toggleSideMenu();
        }
    }
    initAppDatatables();
    initMultiselects('.multiselect');
    initMultiselectsBasic('.multiselectBasic');

    initDatepickers();

    $('.colorpicker').colpick({
        layout: 'hex',
        submit: 0,
        onChange: function (hsb, hex, rgb, el, bySetColor) {
            $(el).css('background-color', '#' + hex).css('color', 'white');
            if (!bySetColor)
                $(el).val(hex);
        }
    }).keyup(function () {
        $(this).colpickSetColor(this.value);
    }).trigger("keyup");
    $('.iconpicker').iconpicker();
    $(".mainGroup").click(function () {
        $(".mainGroupSections").hide();
        $(".mainGroup").removeClass("title");
        $(this).addClass("title");
        var arrId = $(this).attr("id").split("__");
        $("#mainGroupSections__" + arrId[1]).show();
    });

    $("input.number[type=text],input.number[type=number]").on("click", function () {
        $(this).select();
    });

    $('input.email').each(function () {
        var html = '<span class="fa fa-envelope pointer width-5 txt-14 margin-top file-value-icon" onclick="triggerEmailSendInputValue(\'' + $(this).attr("id") + '\');"></span>';
        $(this).removeClass("width-100");
        $(this).addClass("width-95");
        $(this).parent().append(html);
    });

    $('input.phone').each(function () {
        var html = '<span class="fa fa-phone pointer width-5 txt-14 margin-top file-value-icon" onclick="triggerPhoneCallInputValue(\'' + $(this).attr("id") + '\');"></span>';
        $(this).removeClass("width-100");
        $(this).addClass("width-95");
        $(this).parent().append(html);
    });

    if (AppConfig["templateThemeVersion"] >= 2) {
        $('.file-value input.default-currency, .mobile-file-value input.default-currency').each(function () {
            $(this).removeClass("width-100").addClass("width-90");
            $(this).parent().append('<span class="width-10 txt-14 file-value-icon" style="padding:2px 0px 0px 2px;">' + AppConfig["currencySymbol"] + '</span>');
        });
    }

    loadHtmlEditor();
    loadDisctintAutocomplete();
    loadFormGroupCollapsible();
    initCountyTrigger();

    /*Comprobamos sesion activa*/
    if (getPathName() !== "/" && getPathName() !== "/intranet/") {
        var refreshSessionIntervalId = setInterval(function () {
            $.post('/application/refreshSession.php?keepAlive=' + AppConfig["keepAlive"], function (data) {
                try {
                    var jsonData = JSON.parse(data);
                    if (AppConfig["CSRFTokenKey"] !== jsonData["CSRFTokenKey"]) {
                        reloadWindow();
                    }
                } catch (error) {
                    showWolfWarning('<div class="width-100 center padding"><span onclick="reloadWindow();" class="btn btn-lg btn-primary"><i class="fa fa-refresh"></i>&nbsp;Recargar</span></div>', '<i class="fa fa-warning"></i>&nbsp;La sesión ha caducado', "panel-danger", "modal-sm");
                    clearInterval(refreshSessionIntervalId);
                }
            });
        }, 300000);
    }

    $('textarea').each(function () {
        $(this).css('height', (this.scrollHeight + 5) + 'px');
        $(this).css('overflow-y', 'auto');
    }).on('input', function () {
        $(this).css('height', 'auto');
        $(this).css('height', (this.scrollHeight + 5) + 'px');
    });

    loadChildSelectorEvents();

    loadThemeV2Effects();

    loadThemeV3Effects();

    if ($('#frontItemCustomerListId').length !== 0) {
        var defaultList = getLocalStorageItem('frontItemCustomerListId');
        if (defaultList) {
            if ($("#frontItemCustomerListId option[value='" + defaultList + "']").length !== 0) {
                $('#frontItemCustomerListId').val(defaultList);
                reloadCustomerListFrontItem();
            }
        }
    }
});

function getPathName()
{
    if (!window.location || !window.location.pathname) {
        return "";
    }
    return window.location.pathname;
}

function openModal(caption, url, imageGroup)
{
    tb_show(caption, url, imageGroup);
}

function openWindow(url)
{
    if (AppConfig["templateThemeVersion"] < 2) {
        var width = 1000;
        var height = $(window).height();
        var left = ($(window).width() / 2) - (width / 2);
        window.open(addCSRFToken(url), "", 'scrollbars=yes,resizable=yes,modal=yes,top=0,left=' + left + ',width=' + width + ',height=' + height + '');
    } else {
        window.open(addCSRFToken(url));
    }
    return true;
}

function getObjectPath(className, objectId)
{
    var path = callClassMethod("class=" + className + "&objectId=" + objectId + "&method=getObjectPath");
    return path;
}

function openObject(className, objectId, extraParams)
{
    var path = getObjectPath(className, objectId);
    if (path === "") {
        alert("Error retrieving object path");
        return false;
    }
    if (typeof extraParams !== "undefined" && extraParams !== "") {
        if (path.indexOf("?") !== -1) {
            path += "&" + extraParams;
        } else {
            path += "?" + extraParams;
        }
    }
    return openWindow(path);
}

function customerListFinder(callerClass, id, action, defaultFilterGetter, hideCheckboxes)
{
    var auxParams = "";
    if (typeof defaultFilterGetter !== "undefined")
        auxParams += "&defaultFilterGetter=" + defaultFilterGetter;
    if (typeof hideCheckboxes !== "undefined")
        auxParams += "&hideCheckboxes=" + hideCheckboxes;
    return openWindow("/application/customerListFinder.php?callerClass=" + callerClass + "&id=" + id + "&action=" + action + "" + auxParams + "");
}

function contactListFinder(callerClass, id, action, defaultFilterGetter, hideCheckboxes)
{
    var auxParams = "";
    if (typeof defaultFilterGetter !== "undefined")
        auxParams += "&defaultFilterGetter=" + defaultFilterGetter;
    if (typeof hideCheckboxes !== "undefined")
        auxParams += "&hideCheckboxes=" + hideCheckboxes;
    return openWindow("/application/contactListFinder.php?callerClass=" + callerClass + "&id=" + id + "&action=" + action + "" + auxParams + "");
}

function resizeWindow(window, w, h)
{
    var left = ($(window.opener).width() / 2) - (w / 2);
    window.resizeTo(w, h);
    window.moveTo(left, 0);
}

function closeWindow()
{
    window.close();
}

function reloadWindow()
{
    window.location = window.location.href.split('#')[0];
}

function reloadOpener()
{
    if (window.opener && !window.opener.notReloadOnChildClose) {
        window.opener.location = window.opener.location.href.split('#')[0];
    }
}

function goBack()
{
    window.history.back();
}

function redirect(url)
{
    location.href = addCSRFToken(url);
}

function saveObject(keepInFile)
{
    if (AppConfig["templateThemeVersion"] >= 3) {
        showOverlay();
        setTimeout(function () {
            if (!$("#objectForm").valid()) {
                hideOverlay();
                if ($("#showWarningIfSaveObjectFails").val() === "1") {
                    /*Componemos mensaje de error*/
                    var errorRequiredFieldsMsg = "";
                    var nErrorRequiredFields = $("input.error, select.error, textarea.error").length;
                    var errorRequiredFields = [];
                    $("input.error, select.error, textarea.error").each(function () {
                        var label = null;/*$(this).attr("id");*/
                        var inputContainerLabel = $(this).closest(".input-container").find(".input-container-label").first();
                        if (inputContainerLabel.length) {
                            label = inputContainerLabel.html();
                        }
                        if (label) {
                            errorRequiredFields.push(label);
                        }
                    });
                    if (errorRequiredFields.length > 0) {
                        if (nErrorRequiredFields !== errorRequiredFields.length) {
                            errorRequiredFields.push("...");
                        }
                        errorRequiredFieldsMsg += ":<br>&bull;&nbsp;" + errorRequiredFields.join("<br>&bull;&nbsp;");
                    }
                    showWolfWarning('La ficha no se puede guardar' + '<br>' + 'Revise los campos erróneos y vuelva a intentarlo' + errorRequiredFieldsMsg, undefined, 'panel-danger');
                }
                return false;
            }
            if (typeof (saveObjectExtend) === 'function') {
                return saveObjectExtend(keepInFile);
            } else {
                sendObjectForm(keepInFile);
            }
        }, 100);
    } else {
        if ($("#objectForm").valid()) {
            showOverlay();
            if (typeof (saveObjectExtend) === 'function') {
                return saveObjectExtend(keepInFile);
            } else {
                sendObjectForm(keepInFile);
            }
        } else if (AppConfig["templateThemeVersion"] >= 2 && $("#showWarningIfSaveObjectFails").val() === "1") {
            showWolfWarning('La ficha no se puede guardar' + '<br>' + 'Revise los campos erróneos y vuelva a intentarlo', undefined, 'panel-danger');
        }
    }
}

function sendObjectForm(keepInFile) {
    if (typeof (keepInFile) !== "undefined" && keepInFile) {
        $("#cmd").val("saveAndContinue");
    }
    $("#objectForm")[0].submit();
}

function dropObject(id, baseUrl)
{
    if (typeof (dropObjectExtend) == 'function') {
        return dropObjectExtend(id, baseUrl);
    } else {
        var url = 'object.php?cmd=delete&ID=' + id;
        if (typeof baseUrl !== "undefined")
            url = baseUrl + url;
        if (confirm('Seguro que desea borrar esta ficha?'))
        {
            if (location.href.indexOf("object.php?ID=" + id) !== -1) {
                redirect(url);
            } else {
                /*openWindow(url);*/
                showOverlay();
                $.ajax({
                    url: url,
                    timeout: AppConfig.ajaxTimeOut, async: true, type: "GET",
                    success: function (data) {
                        reloadWindow();
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        alert("Error " + xhr.status + ": " + thrownError);
                        hideOverlay();
                    }
                });
            }
        }
    }
}

function disassociateObject(id, baseUrl)
{
    if (typeof (disassociateObjectExtend) == 'function') {
        return disassociateObjectExtend(id, baseUrl);
    } else {
        var url = 'object.php?cmd=disassociate&ID=' + id;
        if (typeof baseUrl !== "undefined")
            url = baseUrl + url;
        if (confirm('Seguro que desea eliminar la asociación?'))
        {
            if (location.href.indexOf("object.php?ID=" + id) !== -1)
            {
                redirect(url);
            } else
            {
                openWindow(url);
            }
        }
    }
}

function disassociateToOtherClientObject(id, baseUrl)
{
    if (typeof (disassociateObjectExtend) == 'function') {
        return disassociateObjectExtend(id, baseUrl);
    } else {
        var url = 'object.php?cmd=disassociateToOtherClientObject&ID=' + id;
        if (typeof baseUrl !== "undefined")
            url = baseUrl + url;
        if (confirm('Si pulsa sobre el botón Aceptar, podrá reasignar la máquina a otro cliente. Una vez asignado el nuevo cliente, es necesario guardar los cambios. Seguro que quiere reasignar la máquina a otro cliente'))
        {
            if (location.href.indexOf("object.php?ID=" + id) !== -1)
            {
                redirect(url);
            } else
            {
                openWindow(url);
            }
        }
    }
}

function duplicateObject(id, baseUrl)
{
    var url = 'object.php?cmd=duplicate&ID=' + id;
    if (typeof baseUrl !== "undefined")
        url = baseUrl + url;
    if (confirm('Seguro que desea duplicar esta ficha?'))
    {
        if (location.href.indexOf("object.php?ID=" + id) !== -1)
        {
            redirect(url);
        } else
        {
            openWindow(url);
        }
    }
}

function duplicateObjectWithoutSave(id, baseUrl)
{
    var url = 'object.php?cmd=duplicateWithoutSave&ID=' + id;
    if (typeof baseUrl !== "undefined")
        url = baseUrl + url;
    if (confirm('Seguro que desea duplicar esta ficha?'))
    {
        if (location.href.indexOf("object.php?ID=" + id) !== -1)
        {
            redirect(url);
        } else
        {
            openWindow(url);
        }
    }
}

function dropFile(id, fieldName)
{
    if (confirm('Seguro que desea eliminar el elemento?'))
    {
        redirect("object.php?ID=" + id + "&cmd=dropFile&fileName=" + fieldName);
    }
}

function downloadFile(id, fieldName, baseUrl)
{
    var url = "object.php?ID=" + id + "&cmd=downloadFile&fileName=" + fieldName;
    if (typeof baseUrl !== "undefined")
        url = baseUrl + url;
    redirect(url);
}

function dropMultiFile(id, fileId)
{
    if (confirm('Seguro que desea eliminar el elemento?'))
    {
        redirect("object.php?ID=" + id + "&cmd=dropMultifile&fileId=" + fileId);
    }
}

function downloadMultiFile(id, fileId, baseUrl)
{
    var url = "object.php?ID=" + id + "&cmd=downloadMultiFile&fileId=" + fileId;
    if (typeof baseUrl !== "undefined")
        url = baseUrl + url;
    redirect(url);
}

function goToURL(url) {
    if (window.event.ctrlKey && AppConfig["templateThemeVersion"] >= 2) {
        openWindow(url);
    } else {
        var opener = getMainWindow(window);
        if (opener !== window) {
            closeWindow();
        }
        opener.redirect(url);
    }
    return true;
}

function goToCustomer(id)
{
    var url = "/customers/section.php?ID=" + id;
    return goToURL(url);
}

function goToProvider(id)
{
    var url = "/providers/section.php?ID=" + id;
    return goToURL(url);
}

function getMainWindow(w)
{
    if (w.opener) {
        try {
            w.opener.location.href;
            return getMainWindow(w.opener);
        } catch (err) {
            return w;
        }
    }
    return w;
}

function loadDisctintAutocomplete()
{
    $.ui.autocomplete.prototype.options.position.collision = "fit none";
    $(".disctint-autocomplete").each(function () {
        var inputName = $(this).attr("name");
        var nameSplit = inputName.split("__");
        var className = $(this).attr("autocompleteClass");
        if (typeof className === "undefined") {
            className = nameSplit[0];
        }
        var value = $(this).attr("autocompleteValue");
        if (typeof value === "undefined") {
            value = nameSplit[1];
        }
        disctintAutocomplete($(this).attr("id"), className, value);
    });
}

function disctintAutocomplete(inputId, className, value, extraParams)
{
    var source = "/application/ajax/callClassMethod.php?class=" + className + "&method=distinctAutocomplete&value=" + value + "";
    if (typeof extraParams !== "undefined") {
        source = source + extraParams;
    }
    $("#" + inputId).autocomplete({
        source: source,
        dataType: "json",
        delay: 300,
        select: function (event, ui) {
            $("#" + inputId).val(ui.item.value).trigger("change").trigger("blur");
        }
    }).data("ui-autocomplete")._renderItem = function (ul, item) {
        return autocompreteRenderItem(ul, item);
    };
}

function autocompreteRenderItem(ul, item)
{
    var label = item.renderedValue;
    var li = $("<li>").addClass("ui-menu-item");
    var a = $("<a>").addClass("ui-corner-all").append(label);
    if (typeof item.BLOCKED !== "undefined" && item.BLOCKED === "1")
        a.css("color", "red");
    if (typeof item.DELETED !== "undefined" && item.DELETED === "1")
        a.css("text-decoration", "line-through");
    li.append(a).appendTo(ul);
    return li;
}

function loadSection(url, container, callback)
{
    if (typeof container === "undefined" || container === "") {
        container = "divSection";
    }
    $("#" + container).html('<div class="width-100 center"><img src="/images/loading.gif" class="margin"/></div>');
    $.ajax({
        type: "POST",
        url: url,
        timeout: AppConfig.ajaxTimeOut,
        async: true,
        success: function (data) {
            $("#" + container).empty();
            $("#" + container).html('<div class="dinamic-section-container">' + data + '</div>');
            if (typeof callback !== "undefined") {
                callback(container);
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            alert("Error " + xhr.status + ": " + thrownError);
            $("#" + container).empty();
        }
    });
}

function loadCustomerSubsections(customerId, sections, container)
{
    if (typeof container === "undefined" || container === "") {
        container = "divCustomerSubsections";
    }
    $("#" + container).html('<span class="width-100 center"><img src="/images/loading.gif"/></span>');
    callClassMethod(
            {class: "Customer", objectId: customerId, method: "renderSubsections", sections: sections},
            true,
            function (data) {
                $("#" + container).empty();
                $("#" + container).html('<div class="dinamic-section-container">' + data + '</div>');
            },
            function () {
                $("#" + container).empty();
            }
    );
}

function loadFormGroupCollapsible()
{
    $(".form-group-collapsible").each(function () {
        var formGroupId = $(this).attr("id");
        var formGroupStatus = getLocalStorageItem(formGroupId);
        if (formGroupStatus === null) {
            setLocalStorageItem(formGroupId, "collapsed");
            formGroupStatus = "collapsed";
        }
        var title = $(this).find(".form-group-title").first();
        title.addClass("pointer");
        var content = $(this).find(".form-group-content").first();
        if (formGroupStatus === "collapsed") {
            content.hide();
            title.addClass("collapsed");
        }
        title.click(function () {
            if (formGroupStatus === "collapsed" || formGroupStatus === null) {
                content.show();
                title.removeClass("collapsed");
                setLocalStorageItem(formGroupId, "");
            } else {
                content.hide();
                title.addClass("collapsed");
                setLocalStorageItem(formGroupId, "collapsed");
            }
            formGroupStatus = getLocalStorageItem(formGroupId);
        });
    });
}

function openCollapsedFormGroupsWithErrors()
{
    /*Recorremos los posibles form-group cerrados que contengan inputs no validos*/
    $(".form-group-collapsible").each(function () {
        if (getLocalStorageItem($(this).attr("id")) === "collapsed" && $(this).find(".required.error").length !== 0) {
            $(this).find(".form-group-title").trigger("click");
        }
    });
}

function getObjectFields(callerClass, objectId, fields)
{
    var ret = [];
    $.ajax({
        type: "POST",
        url: "/application/ajax/getObjectFields.php",
        data: {
            callerClass: callerClass,
            objectId: objectId,
            fields: fields
        },
        timeout: AppConfig.ajaxTimeOut,
        async: false,
        success: function (data) {
            ret = $.parseJSON(data);
        },
        error: function (xhr, ajaxOptions, thrownError) {
            ret = false;
        }
    });
    return ret;
}

function loadObjectData(className, objectId)
{
    if (typeof objectId === "undefined" || objectId === "" || objectId === "0") {
        return false;
    }
    $.ajax({
        url: "/application/ajax/getObjectData.php",
        async: false,
        type: "POST",
        data: {
            className: className, ID: objectId},
        dataType: "json",
        success: function (data) {
            if (data["result"] > 0) {
                if (typeof data["DATA"]["COUNTRY"] !== "undefined") {
                    $('#' + className + '__COUNTRY').val(data["DATA"]["COUNTRY"]);
                    $('#' + className + '__COUNTRY').trigger("change");
                }
                $.each(data["DATA"], function (k, v) {
                    if ($('#' + className + '__' + k).length) {
                        $('#' + className + '__' + k).val(v);
                        if (typeof data["READ_ONLY"][k] !== "undefined") {
                            $('#' + className + '__' + k).prop("readonly", true);
                            $('#' + className + '__' + k).css("border", "1px solid red");
                            if ($('#' + className + '__' + k).is("select")) {
                                $('#' + className + '__' + k).prop("disabled", true);
                            }
                        } else {
                            $('#' + className + '__' + k).prop("readonly", false);
                            $('#' + className + '__' + k).css("border", "");
                            if ($('#' + className + '__' + k).is("select")) {
                                $('#' + className + '__' + k).prop("disabled", false);
                            }
                        }
                    }
                });
            } else {
                alert("{$_t->_('Error')}\n" + data["response"]);
            }
        }
    });
    return true;
}

function loadChildSelectorEvents()
{

    var wolfChildSelectorOptions = [];

    $("select.child-selector").each(function () {
        var child = $(this);
        var childId = child.attr("id");
        var currentChildValue = child.val();
        if (typeof $(this).attr("full-parent-field-name") !== "undefined") {
            var parentId = $(this).attr("full-parent-field-name");
        } else {
            var aux = childId.split("__");
            var className = aux[0];
            var parentId = className + "__" + $(this).attr("parent-field-name");
        }
        var parent = $("#" + parentId);
        if (child.length && parent.length) {
            parent.change(function () {
                if (!wolfChildSelectorOptions[childId]) {
                    wolfChildSelectorOptions[childId] = $("#" + childId + " option").clone();
                }
                $.each($("#" + childId + " option"), function () {
                    $(this).remove();
                });

                if (parent.hasClass("multiselect")) {
                    var parentValues = $(this).val();
                    parentValues.push("");
                } else {
                    var parentValues = [$(this).val()];
                }

                $.each(wolfChildSelectorOptions[childId], function () {
                    var childOption = $(this);
                    $.each(parentValues, function (kParentValue, parentValue) {
                        if (!child.hasClass("multiselect") || childOption.val() !== "") {
                            if ((!childOption.attr("parent-selector-id") && !childOption.attr("other-parents-selector-id")) || childOption.attr("parent-selector-id") === parentValue || (childOption.attr("other-parents-selector-id") && childOption.attr("other-parents-selector-id").indexOf("|" + parentValue + "|") !== -1)) {
                                child.append(childOption);
                                return true;
                            }
                        }
                    });
                });
                if (child.hasClass("multiselect")) {
                    child.val(currentChildValue).multiselect("rebuild").trigger("change");
                } else {
                    if ($("#" + childId + " option[value='" + currentChildValue + "']").length) {
                        child.val(currentChildValue).trigger("change");
                    } else {
                        child.val("").trigger("change");
                    }
                }
            });
            parent.trigger("change");
        }
    });
}

function callClassMethod(data, asyncCall, callback, errorCallback, callerExtraParams)
{
    var ret = null;
    var async = (asyncCall === true ? true : false);
    var extraParams = (typeof callerExtraParams === "undefined" ? {} : callerExtraParams);
    var timeout = (extraParams["timeout"] ? extraParams["timeout"] : AppConfig.ajaxTimeOut);

    $.ajax({
        url: "/application/ajax/callClassMethod.php",
        timeout: timeout, async: async, type: "POST", data: data,
        success: function (data) {
            ret = data;
            if (typeof callback !== "undefined") {
                callback(ret);
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (thrownError !== "") {
                if (extraParams["silencedError"] !== true) {
                    alert("Error " + xhr.status + ": " + thrownError);
                }
                if (typeof errorCallback !== "undefined") {
                    errorCallback(xhr, ajaxOptions, thrownError);
                }
            }
        }
    });
    return ret;
}

function callClassMethodAsyncJsonResponse(data, callback, callerExtraParams)
{
    var extraParams = (typeof callerExtraParams === "undefined" ? {} : callerExtraParams);
    var sOverlay = ((extraParams["showOverlay"] === false) ? false : true);
    if (sOverlay === true) {
        showOverlay();
    }
    var ret = callClassMethod(data, true,
            function (data) {
                try {
                    var jsonData = JSON.parse(data);
                    if (jsonData["result"] && jsonData["result"] >= 0) {
                        if (typeof callback !== "undefined") {
                            callback(jsonData);
                        }
                    } else {
                        alert(jsonData["error"]);
                    }
                } catch (error) {
                    alert(error);
                }
                if (sOverlay === true) {
                    hideOverlay();
                }
            },
            function () {
                if (sOverlay === true) {
                    hideOverlay();
                }
            },
            extraParams
            );
    return ret;
}

function disableInputsContainer(containerId)
{
    var notSelector = ':button,:hidden';
    if ($("#objectForm").length && typeof objectFormEditable !== "undefined" && !objectFormEditable) {
        var notSelector = ':button';
    }

    $("#" + containerId).find('input').not(notSelector).each(function () {
        if ($(this).attr('type') !== "search" && $(this).attr('type') !== "hidden") {
            $(this).attr('disabled', 'true');
        }
    });
    $("#" + containerId).find("textarea").each(function () {
        $(this).attr('disabled', 'true');
    });
    $("#" + containerId).find("select").each(function () {
        if (typeof $(this).attr("name") === "undefined" || $(this).attr("name").substring(0, 16) !== "DataTables_Table") {
            $(this).attr('disabled', 'true');
            if ($(this).hasClass("multiselect")) {
                $(this).multiselect('disable');
                $(this).parent().find("button.multiselect").addClass("no-border");
            }
        }
    });
}

function disableInputsClass(className)
{
    $("." + className).each(function () {
        $(this).attr('disabled', 'true');
        $(this).removeClass("error");
        $('label[for="' + $(this).attr('id') + '"]').hide();
    });
}

function enableInputsClass(className)
{
    $("." + className).each(function () {
        $(this).removeAttr('disabled');
    });
}

function trim(str)
{
    str = str.replace(/^\s+/, '');
    for (var i = str.length - 1; i >= 0; i--) {
        if (/\S/.test(str.charAt(i))) {
            str = str.substring(0, i + 1);
            break;
        }
    }
    return str;
}

function pad(str, max)
{
    str = str.toString();
    return str.length < max ? pad("0" + str, max) : str;
}

function initMultiselects(selector)
{
    $(selector).each(function () {
        var multiselectOptions = {
            enableCaseInsensitiveFiltering: true,
            enableFiltering: true,
            includeSelectAllOption: true,
            maxHeight: ($(this).attr("maxHeight") ? $(this).attr("maxHeight") : null)
        };
        if (AppConfig["templateThemeVersion"] >= 3) {
            if (!multiselectOptions["maxHeight"]) {
                multiselectOptions["maxHeight"] = 300;
            }
        }
        $(this).multiselect(multiselectOptions);
    });
    return true;
}

function initMultiselectsBasic(selector)
{
    $(selector).each(function () {
        $(this).multiselect();
    });
    return true;
}

function initDatepickers()
{
    addDatepicker(".datepicker");
    addDatetimepicker(".datetimepicker");
    addTimepicker('.timepicker');
    addDatepickerYears(".datepickerYears");
    addProjectTimepicker('.projectTimepicker');

    if (AppConfig["mobileDevice"] === 1) {
        $(".datepicker, .timepicker, .datepickerYears, .projectTimepicker, .datetimepicker").attr("readonly", true);
        if (AppConfig["templateThemeVersion"] >= 3) {
            $(".datepicker, .timepicker, .datepickerYears, .projectTimepicker, .datetimepicker").addClass("datepicker-not-manual-input");
            $(".datepicker").css("width", "85px");
        }
    }

}

function addDatepicker(key)
{
    $(key).addClass("valid-datepicker-value").datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat: 'dd/mm/yy',
        firstDay: 1,
        onClose: function () {
            $(this).trigger("change").trigger("blur");
        }
    });
}

function addDatepickerYears(key)
{
    $(key).addClass("valid-datepicker-value").datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat: 'dd/mm/yy',
        yearRange: '-120:+0',
        onClose: function () {
            $(this).trigger("change").trigger("blur");
        }
    });
}

function addDatetimepicker(key)
{
    $(key).each(function () {
        var stepMinute = ((typeof $(this).attr("datepickerStepMinute") !== "undefined") ? (1 * $(this).attr("datepickerStepMinute")) : 1);
        if (stepMinute !== 1) {
            /*Fix si pasamos un step ya que si la hora no coincide con los valores del step el timepicker nos falla*/
            var time = $(this)[0]['defaultValue'].split(":");
            var minutes = time[1]; /*Cogemos los minutos de la hora*/
            var minutesFixed = (Math.trunc(minutes / stepMinute) * stepMinute) + "";
            if (minutesFixed.length === 1) {
                minutesFixed = "0" + minutesFixed; /*Si el redondeo es menor que 10 ponemos 0 delante*/
            }
            $(this)[0]['defaultValue'] = time[0] + ":" + minutesFixed;
        }
        $(this).addClass("valid-datepicker-value").datetimepicker({
            stepMinute: stepMinute,
            changeMonth: true,
            changeYear: true,
            dateFormat: 'dd/mm/yy',
            controlType: 'select',
            firstDay: 1,
            onClose: function () {
                $(this).trigger("change").trigger("blur");
            }
        });
    });
}

function addTimepicker(key)
{
    $(key).timepicker({
        controlType: 'select',
        timeText: '',
        onClose: function () {
            $(this).trigger("change").trigger("blur");
        }
    });
}

function addProjectTimepicker(key)
{
    $(key).timepicker({
        stepMinute: 5,
        hourMax: 12,
        showButtonPanel: false,
        controlType: 'select',
        timeText: '',
        onClose: function () {
            $(this).trigger("change").trigger("blur");
        }
    });
}

function getMonthsDiff(date1, date2)
{
    if (!date1 || !date2) {
        return 0;
    }

    var months;
    months = (date2.getFullYear() - date1.getFullYear()) * 12;
    months -= date1.getMonth();
    months += date2.getMonth();
    return months <= 0 ? 0 : months;
}

function getMonthsDiffDatepicker(inputId1, inputId2)
{
    var date1 = $("#" + inputId1).datepicker('getDate');
    var date2 = $("#" + inputId2).datepicker('getDate');
    return getMonthsDiff(date1, date2);
}

function getWeekForDate(date, includeYear)
{

    if (!date) {
        return "";
    }

    if (typeof includeYear === "undefined") {
        includeYear = false;
    }

    var week = $.datepicker.iso8601Week(date);

    if (includeYear) {
        var year = date.getFullYear();
        var month = (date.getMonth() + 1);
        if (week === 1 && month === 12) {
            year = year + 1;
        }
        week = week + "-" + year;
    }

    return week;
}

function getWeekForDateDatepicker(inputId, includeYear)
{
    var date = $("#" + inputId).datepicker('getDate');
    return getWeekForDate(date, includeYear);
}

function loadHtmlEditor()
{
    var target = "textarea.html-editor";
    if (!$(target).length) {
        return false;
    }

    var extraPlugins = "";
    var extraToolbar = "";
    if ($(target).hasClass("html-editor-full-page")) {
        extraPlugins = extraPlugins + " fullpage";
        extraToolbar = extraToolbar + " fullpage";
    } else {
        extraPlugins = extraPlugins + " autoresize";
    }

    tinymce.init({
        selector: target,
        language: AppConfig.lang,
        /*content_css: "/css/main.php?css=/css/main.css",*/
        plugins: [
            "advlist autolink lists link image charmap print preview hr anchor pagebreak",
            "searchreplace wordcount visualblocks visualchars code fullscreen",
            "insertdatetime nonbreaking save table directionality",
            "emoticons template paste responsivefilemanager" + extraPlugins
        ],
        menubar: 'file edit insert view format table tools',
        toolbar: "bold italic underline alignleft aligncenter alignright alignjustify | forecolor backcolor | styleselect | fontselect | fontsizeselect | bullist numlist | outdent indent | link unlink image responsivefilemanager template" + extraToolbar,
        verify_html: false,
        valid_children: "+body[style]",
        allow_conditional_comments: true,
        convert_urls: false,
        relative_urls: false,
        remove_script_host: false,
        force_br_newlines: true,
        force_p_newlines: false,
        forced_root_block: '',
        autoresize_min_height: 100,
        autoresize_bottom_margin: 15,
        height: "80vh",
        fullpage_default_encoding: "UTF-8",
        fullpage_default_font_size: "16px",
        fullpage_default_font_family: "\'Source Sans Pro\', \'Helvetica Neue\', Helvetica, Arial, sans-serif;",
        contextmenu_never_use_native: true,
        fontsize_formats: '6px 8px 10px 12px 14px 16px 18px 20px 22px 24px 30px 36px 48px',
        table_default_attributes: {
            border: '0'
        },
        external_filemanager_path: "/js/tinymce_522/js/tinymce/plugins/responsivefilemanager/filemanager/",
        external_plugins: {
            "responsivefilemanager": "/js/tinymce_522/js/tinymce/plugins/responsivefilemanager/tinymce/plugins/responsivefilemanager/plugin.min.js"
        },
        templates: addCSRFToken("/application/ajax/callClassMethod.php?class=NewsletterTemplate&method=getTinyMceTemplates"),
        init_instance_callback: function (editor) {
            editor.on('Change', function () {
                editor.save();
            });
        }
    });
    return true;
}

function duplicateTinyMceBlock()
{
    var node = $(tinyMCE.activeEditor.selection.getNode());
    var table = node.parents('table.mce-item-table').first();
    var html = $('<div>').append(table.clone()).html();
    $(html).insertBefore(table);
    return true;
}

function getFormattedTime()
{
    var date = new Date();
    var hour = date.getHours().toString();
    if (hour.length === 1)
    {
        hour = "0" + hour;
    }
    var minutes = date.getMinutes().toString();
    if (minutes.length === 1)
    {
        minutes = "0" + minutes;
    }
    return hour + ":" + minutes;
}

function showOverlay()
{
    if ($("#bodyOverlay").length) {
        return false;
    }
    var overlayHeight = "100%";
    if ($(window).height()) {
        overlayHeight = $(window).height() + "px";
        if ($("body").height() && $("body").height() > $(window).height()) {
            overlayHeight = $("body").height() + "px";
        }
    }
    var overlay = '<div id="bodyOverlay" style="height:' + overlayHeight + ';"><img id="bodyOverlayLoading" src="/images/loading.gif"></div>';
    $(overlay).appendTo('body');
    return true;
}

function hideOverlay()
{
    if (!$("#bodyOverlay").length) {
        return false;
    }
    $('#bodyOverlay').remove();
    return true;
}

function appScrollTo(containerId)
{
    var container = $('#' + containerId);
    if (container.length) {
        var offset = 0;
        if ($("#content-container").length) {
            var contentContainerPadding = parseInt($("#content-container").css("padding-top"));
            if (!isNaN(contentContainerPadding)) {
                offset = offset + contentContainerPadding;
            }
        }
        $(window).scrollTop(container.offset().top - offset);
        return true;
    }
    return false;
}

function appDateFormat(sqlDate)
{
    if (sqlDate && sqlDate != "" && sqlDate != "0000-00-00")
        return $.datepicker.formatDate('dd/mm/yy', new Date(sqlDate));
    return "";
}

function appDateTimeFormat(sqlDate)
{
    if (!sqlDate || sqlDate == "") {
        return "";
    }
    var parts = sqlDate.split(" ");
    var date = appDateFormat(parts[0]);
    if (date == "") {
        return "";
    }
    var time = parts[1].substring(0, 5);
    return date + " " + time;
}

function appNumberFormat(number, decimals)
{
    if (typeof decimals === "undefined") {
        decimals = (AppConfig.decimals * 1);
    }
    return numberFormat(number, decimals, AppConfig.decimalSeparator, AppConfig.thousandsSeparator);
}

function appRound(number)
{
    number = (number * 1);
    return number.toFixed((AppConfig.decimals * 1));
}

function appParseFloat(appNumber)
{
    return 1 * (appNumber.split(AppConfig.thousandsSeparator).join("").split(AppConfig.decimalSeparator).join("."));
}

function numberFormat(number, decimals, decPoint, thousandsSep)
{

    if (typeof decimals == "undefined") {
        decimals = 2;
    }
    if (typeof decPoint == "undefined") {
        decPoint = ",";
    }
    if (typeof thousandsSep == "undefined") {
        thousandsSep = ".";
    }

    number = (number + '').replace(/[^0-9+\-Ee.]/g, '');
    var n = !isFinite(+number) ? 0 : +number,
            prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
            sep = (typeof thousandsSep === 'undefined') ? ',' : thousandsSep,
            dec = (typeof decPoint === 'undefined') ? '.' : decPoint,
            s = '',
            toFixedFix = function (n, prec) {
                var k = Math.pow(10, prec);
                return '' + (Math.round(n * k) / k).toFixed(prec);
            };
    s = (prec ? toFixedFix(n, prec) : '' + Math.round(n)).split('.');
    if (s[0].length > 3) {
        s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
    }
    if ((s[1] || '').length < prec) {
        s[1] = s[1] || '';
        s[1] += new Array(prec - s[1].length + 1).join('0');
    }
    return s.join(dec);
}

function numberFormatInput(number, decimals)
{
    return numberFormat(number, decimals, '.', '');
}

function normalizeString(str, toLower) {
    if (typeof toLower !== "undefined" && toLower) {
        str = str.toLowerCase();
    }
    return str.normalize("NFD").replace(/[\u0300-\u036f]/g, "");
}

function initCountyTrigger()
{
    var formCountySelected = {};
    $(".countyTrigger").change(function () {
        var countyId = $(this).attr("id").replace("COUNTRY", "COUNTY");
        if (typeof formCountySelected[countyId] === "undefined") {
            formCountySelected[countyId] = "";
        }
        if ($("#" + countyId).val() && $("#" + countyId).val() !== null) {
            formCountySelected[countyId] = $("#" + countyId).val();
        }
        getCountiesByCountry($(this).val(), $(this).attr("countyTarget"), $(this).attr("defaultCounty"), formCountySelected[countyId]);
    });
    $(".countyTrigger").trigger("change");
}

function getCountiesByCountry(country, target, selected, formCountySelected)
{
    if (formCountySelected) {
        selected = formCountySelected;
    }
    var multiselect = "0";
    if ($("#" + target).attr("multiple")) {
        multiselect = "1";
    }

    var async = false;
    if ($("#" + target).attr("getOptionsAsync")) {
        async = true;
    }

    $.ajax({
        data: {format: "html", country: country, target: target, selected: selected, multiselect: multiselect, selectUnasigned: ($("#" + target).hasClass("select-unassigned") ? "1" : "0")},
        url: '/application/ajax/getCountiesByCountry.php', type: "POST",
        timeout: AppConfig.ajaxTimeOut, async: async,
        success: function (data) {
            $("#" + target).empty();
            $("#" + target).html(data);
            if ($("#" + target).hasClass("multiselect")) {
                $("#" + target).multiselect('rebuild');
            }
            if (async) {
                $("#" + target).trigger("change");
            }
        }
    });
}

function uniqId()
{
    return Math.round(new Date().getTime() + (Math.random() * 100));
}

function sortSelectbyName(id)
{
    var selectToSort = $('#' + id);
    var optionActual = selectToSort.val();
    selectToSort.html(selectToSort.children('option').sort(function (a, b) {
        return a.text === b.text ? 0 : a.text < b.text ? -1 : 1;
    })).val(optionActual);
}

function sortSelectbyNameDesc(id)
{
    var selectToSort = $('#' + id);
    var optionActual = selectToSort.val();
    selectToSort.html(selectToSort.children('option').sort(function (a, b) {
        return a.text === b.text ? 0 : a.text > b.text ? -1 : 1;
    })).val(optionActual);
}

function renderSelect(id, name, options, selected, classes, onchange, attr, emptyOptionName)
{
    if (typeof selected === "undefined") {
        selected = "";
    }
    if (typeof classes === "undefined") {
        classes = "";
    }
    if (typeof onchange === "undefined") {
        onchange = "";
    } else {
        onchange = 'onchange="' + onchange + '"';
    }
    if (typeof attr === "undefined") {
        attr = "";
    }
    if (typeof emptyOptionName === "undefined") {
        emptyOptionName = "...";
    }

    var html = '<select name="' + name + '" id="' + id + '" ' + attr + ' ' + onchange + ' class="' + classes + '">';
    if (attr.indexOf("multiple") === -1 && classes.indexOf("no-empty-value") === -1) {
        html += '<option value="">' + emptyOptionName + '</option>';
    }
    $.each(options, function (k, v) {
        var optionClasses = "";
        if (v["class"]) {
            optionClasses = v["class"];
        }

        var optionAttr = "";
        if (v["inputAttr"]) {
            optionAttr = v["inputAttr"];
        }

        html += '<option value="' + $.trim(k) + '" class="' + optionClasses + '" ' + optionAttr + '>' + v["NAME"] + '</option>';
    });
    html += '</select>';
    if (selected !== null) {
        if (typeof selected === "object" && selected.length > 0) {
            $.each(selected, function (selectedIndex, selectedValue) {
                html = html.replace('<option value="' + selectedValue + '"', '<option selected value="' + selectedValue + '"');
            });
        } else {
            html = html.replace('<option value="' + selected + '"', '<option selected value="' + selected + '"');
        }
    }
    return html;
}

function renderInputText(id, name, value, classes, attr)
{
    if (typeof value == "undefined") {
        value = "";
    } else if (typeof value === "string") {
        value = value.split('"').join("'");
    }
    if (typeof classes == "undefined") {
        classes = "";
    }
    if (typeof attr == "undefined") {
        attr = "";
    }

    var nameAttr = "";
    if (typeof name !== "undefined" && name !== "") {
        nameAttr = 'name="' + name + '"';
    }
    var html = '<input type="text" ' + nameAttr + ' id="' + id + '" value="' + value + '" class="' + classes + '" ' + attr + '/>';
    return html;
}

function renderInputTextArea(id, name, value, classes, attr)
{
    if (typeof value == "undefined") {
        value = "";
    } else if (typeof value === "string") {
        value = value.split('"').join("'");
    }
    if (typeof classes == "undefined") {
        classes = "";
    }
    if (typeof attr == "undefined") {
        attr = "";
    }

    var nameAttr = "";
    if (typeof name !== "undefined" && name !== "") {
        nameAttr = 'name="' + name + '"';
    }
    var html = '<textarea type="text" ' + nameAttr + ' id="' + id + '" class="' + classes + '" ' + attr + '>' + value + '</textarea>';
    return html;
}

function renderInputHidden(id, name, value, classes)
{
    if (typeof value == "undefined") {
        value = "";
    }
    if (typeof classes == "undefined") {
        classes = "";
    }
    var html = '<input type="hidden" name="' + name + '" id="' + id + '" value="' + value + '" class="' + classes + '"/>';
    return html;
}

function renderIcon(css, style, title)
{
    if (typeof style !== "undefined") {
        style = 'style="' + style + '"';
    } else {
        style = '';
    }
    if (typeof title !== "undefined") {
        title = 'title="' + title + '"';
    } else {
        title = '';
    }
    return '<i class="' + css + '" ' + style + ' ' + title + '></i>';
}

function renderPhoneTag(phone)
{
    if (typeof phone === "undefined" || phone === "") {
        return "";
    }
    var html = '<a href="tel:' + phone + '">' + phone + '</a>';
    return html;
}

function renderEmailTag(email)
{
    if (typeof email === "undefined" || email === "") {
        return "";
    }
    var html = '<a href="mailto:' + email + '">' + email + '</a>';
    return html;
}

function renderWebTag(web)
{
    if (typeof web === "undefined" || web === "") {
        return "";
    }
    if (web.substr(0, 4) !== "http") {
        web = "http://" + web;
    }
    var html = '<a target="_blank" href="' + web + '" rel="noreferrer">' + web + '</a>';
    return html;
}

function triggerPhoneCallInputValue(inputId)
{
    return triggerPhoneCall($("#" + inputId).val());
}

function triggerPhoneCall(number)
{
    if (number !== "") {
        window.location = 'tel:' + number + '';
    }
}

function triggerEmailSendInputValue(inputId)
{
    return triggerEmailSend($("#" + inputId).val());
}

function triggerEmailSend(email)
{
    if (email !== "") {
        window.location = 'mailto:' + email + '';
    }
}

function setLocalStorageItem(keyName, keyValue)
{
    try {
        localStorage.setItem(keyName, keyValue);
        return keyValue;
    } catch (e) {
        console.log(e.message);
        return null;
    }
}

function getLocalStorageItem(keyName)
{
    try {
        return localStorage.getItem(keyName);
    } catch (e) {
        console.log(e.message);
        return null;
    }
}

function exportHtmlTag(tagId, fileName, outputFormat)
{

    if (!$('#' + tagId).length) {
        alert('Debe generar primero el contenido');
        return false;
    }

    /*Mostramos todos los registros de los datatables que vayamos a exportar y guardamos su valor original*/
    var previousDataTablePageLength = {
    };
    $('#' + tagId).find("select").each(function () {
        if ($(this).attr("name").indexOf("DataTables_Table_") !== -1 && $(this).attr("name").indexOf("_length") !== -1 && $(this).find("option[value='-1']").length) {
            previousDataTablePageLength[$(this).attr("name")] = $(this).val();
            $(this).val("-1").trigger("change");
        }
    });

    /*Generamos el contenido a exportar*/
    var content = $('#' + tagId).clone();
    content.find(".dt-header,.dt-footer,.no-print").remove();
    content.find("th").css("background-color", "#CCCCCC");
    var html = content.html();

    /*Volvemos a poner los paginadores de los datatables como estaban*/
    $.each(previousDataTablePageLength, function (k, v) {
        $('select[name=' + k + ']').val(v).trigger("change");
    });

    /*Exportamos el contenido apoyandonos en un formulario temporal*/
    var exportHtmlTagForm = '<form action="/application/exportHtml.php" method="post" name="exportHtmlTagForm" id="exportHtmlTagForm">';
    exportHtmlTagForm += '<input type="hidden" name="fileName" id="fileName" value="' + fileName + '"/>';
    exportHtmlTagForm += '<input type="hidden" name="outputFormat" id="outputFormat" value="' + outputFormat + '" />';
    exportHtmlTagForm += '<input type="hidden" name="html" id="html" value="' + encodeURIComponent(html) + '" />';
    exportHtmlTagForm += '</form>';
    $("body").append(exportHtmlTagForm);
    $("#exportHtmlTagForm").submit();
    $("#exportHtmlTagForm").remove();
    return true;
}

function showWolfWarning(content, title, type, modalSize, closeTime)
{

    if (typeof title === "undefined") {
        title = '¡Atención!';
    }
    if (typeof type === "undefined") {
        type = 'panel-warning';
    }
    if (typeof modalSize === "undefined") {
        modalSize = '';
    }
    if ($("#wolfWarningPopupContainer").length) {
        $("#wolfWarningPopupContainer").remove();
        $('.modal-backdrop').last().remove();
    }
    var html = '<div id="wolfWarningPopupContainer" class="modal fade" role="dialog">';
    html += '<div class="modal-dialog ' + modalSize + '" role="document">';
    html += '<div class="panel ' + type + '">';
    html += '<div class="panel-heading"><span class="modal-title txt-20" id="wolfWarningPopupTitle">' + title + '</span><span id="wolfWarningPopupContainerBtnDismiss" class="btn btn-xs btn-grey pull-right" data-dismiss="modal">&nbsp;X&nbsp;</span></div>';
    html += '<div id="wolfWarningPopupContent" class="panel-body">' + content + '</div>';
    html += '</div>';
    html += '</div>';
    html += '</div>';
    $('body').append(html);
    $('#wolfWarningPopupContainer').modal('show');
    if (typeof closeTime !== "undefined") {
        setTimeout(function () {
            $("#wolfWarningPopupContainer").modal("hide");
        }, closeTime);
    }
}

function toggleSideMenu()
{
    if ($("#side-menu-container").hasClass("side-menu-collapsed")) {
        $("#side-menu-container").removeClass("side-menu-collapsed");
        $("#main-section-container").removeClass("side-menu-collapsed");
        $("#side-menu-toggle").removeClass("glyphicon-chevron-right").addClass("glyphicon-chevron-left");
        setLocalStorageItem("side-menu-size", "");
    } else {
        $("#side-menu-container").addClass("side-menu-collapsed");
        $("#main-section-container").addClass("side-menu-collapsed");
        $("#side-menu-toggle").removeClass("glyphicon-chevron-left").addClass("glyphicon-chevron-right");
        setLocalStorageItem("side-menu-size", "collapsed");
    }
    if ($('.masonry')[0]) {
        $('.grid').masonry('reload');
    }
}

function v3ObjectInputFileChange(element) {
    var label = $("#inputFileLabel_" + $(element).attr("id"));
    if (!label.length) {
        return false;
    }
    var fileName = ($(element)[0].files[0] ? $(element)[0].files[0].name : (label.data("original-value") ? label.data("original-value") : '...'));
    label.text(fileName);
}

function loadThemeV2Effects()
{
    if (AppConfig["templateThemeVersion"] < 2) {
        return false;
    }

    $("input,select,textarea").on("cssClassChanged", function () {
        highlightRequiredField($(this));
    });
    $(".required").each(function () {
        $(this).trigger("cssClassChanged");
    });
    $(".input-important").each(function () {
        $(this).parents(".input-container").first().addClass("file-field-important");
    });

    var jQueryDefaultAddClass = jQuery.fn.addClass;
    jQuery.fn.addClass = function () {
        /*Execute the original method.*/
        var result = jQueryDefaultAddClass.apply(this, arguments);

        /*trigger a custom event*/
        $(this).trigger('cssClassChanged');

        /*return the original result*/
        return result;
    };
    var jQueryDefaultRemoveClass = jQuery.fn.removeClass;
    jQuery.fn.removeClass = function () {
        /*Execute the original method.*/
        var result = jQueryDefaultRemoveClass.apply(this, arguments);

        /*trigger a custom event*/
        $(this).trigger('cssClassChanged');

        /*return the original result*/
        return result;
    };
    var jQueryDefaultHtml = jQuery.fn.html;
    jQuery.fn.html = function () {
        /*Execute the original method.*/
        var result = jQueryDefaultHtml.apply(this, arguments);

        /*trigger a custom event*/
        $(this).find("input,select,textarea").each(function () {
            highlightRequiredField($(this));
        });

        /*return the original result*/
        return result;
    };

    loadThemeV2Tooltips();

    return true;
}

function loadThemeV3Effects() {

    if (AppConfig["templateThemeVersion"] < 3) {
        return false;
    }

    (function ($) {

        /* Sobreescribo autocomplete para ponerle parámetros por defecto */
        var autocompleteDefault = $.fn.autocomplete;
        $.fn.autocomplete = function (options) {
            if (typeof options === "object") {
                options = $.extend(true, options, {
                    position: {
                        my: "left top", at: "left bottom", collision: "flip"
                    }
                });
            }
            return autocompleteDefault.apply(this, arguments);
        };

    })(jQuery);

    /*Ajustamos posibles colisiones para los dropdowns*/
    $('.btn-group').on('shown.bs.dropdown', function () {
        var menu = $(this).find('ul.dropdown-menu');
        if ((menu !== null) && (menu.length === 1)) {
            menu.removeClass("pull-right").css({"right": "auto"}).position({of: menu.parent(), my: "left top", at: "left bottom", collision: "flipfit"});
        }
    });

    /*Ajustamos las modales de los filtros de los informes*/
    if ($("#reportFormModalContainer #reportForm").length === 1) {
        var reportForm = $("#reportFormModalContainer #reportForm");
        var reportFormMaxHeight = '85vh';
        if (!$("#reportFormModalContainer").hasClass("modal")) {
            reportFormMaxHeight = ($(window).height() - reportForm.offset().top - 50);
        }
        reportForm.css("min-height", reportFormMaxHeight);
    }

    /*Ajustamos los filtros de cliente*/
    /*
     if ($("#customersForm div.panel-body").length === 1) {
     var customersFormMaxHeight = ($(window).height() - $("#customersForm div.panel-body").offset().top - 10);
     $("#customersForm div.panel-body").css({
     "height": (customersFormMaxHeight > 0 ? customersFormMaxHeight : "300px"),
     "overflow-y": "auto"
     });
     }
     */
    /*Ajustamos los filtros de contacto*/
    /*
     if ($("#contactsForm div.panel-body").length === 1) {
     var contactsFormMaxHeight = ($(window).height() - $("#contactsForm div.panel-body").offset().top - 10);
     $("#contactsForm div.panel-body").css({
     "height": (contactsFormMaxHeight > 0 ? contactsFormMaxHeight : "300px"),
     "overflow-y": "auto"
     });
     }
     */

    if (AppConfig["mobileVersion"] === 1) {
        /*Vista móvil*/

        if ($(".form-actions").length === 1) {
            $(".form-actions div").css("font-size", "14px").css("line-height", "18px");
            $(".form-actions .btn").addClass("txt-20 padding");
        }

        if ($(".object-header-container").length === 1 && $(".object-actions-container").length === 1) {

            $(".width-50.title").addClass("margin-top padding txt-16");
            $("#openCartButton, #openPromotionsButton").addClass("margin-top txt-16").css("padding", "5px 10px 5px 10px");
            $(".btn.btn-xs.btn-default").removeClass("btn-xs").addClass("btn-sm");

            $(".object-actions-container").hide();
            $(".object-outside-actions-container").hide();
            $(".object-actions-container .btn").detach().appendTo(".object-actions-container");
            $(".object-outside-actions").detach().prependTo(".object-actions-container");
            $(".save-object-continue-btn, .save-object-btn, .close-object-btn").detach().prependTo(".object-actions-container");
            $(".object-actions-container .object-primary-action").detach().prependTo(".object-actions-container");
            $(".delete-object-btn").detach().appendTo(".object-actions-container");
            $(".object-actions-container .btn").addClass("object-actions-container-btn").css("width", "20%").css("height", "50px").css("line-height", "125%").addClass("condensed");
            $(".object-actions-container :not(.btn)").hide();


            var nActions = $(".object-actions-container-btn").length;
            if (nActions > 4) {
                /*Agrupamos los botones en un submenu si hay mas de 4*/
                var btnGroup = '<span class="btn btn-sm dropdown-toggle btn-grey" data-toggle="modal" data-target="#objectActionsContainerModal" style="width:20%;height: 50px;">';
                btnGroup += '<i class="fa fa-list txt-40" style="padding-top: 2px;"></i>';
                btnGroup += '</span>';
                btnGroup += '<div id="objectActionsContainerModal" class="modal fade">';

                btnGroup += '<div class="modal-dialog modal-sm" style="position: fixed; bottom: 45px;width: 300px;left: 50%;margin-left: -150px;">';
                btnGroup += '<div class="modal-content title" style="white-space: normal;border:0px;border-radius:0px;">';
                btnGroup += '<div class="row">';

                btnGroup += '<div class="col-xs-12 right">';
                btnGroup += '<span class="fa fa-close txt-30 padding pointer" data-dismiss="modal"></span>';
                btnGroup += '</div>';
                btnGroup += '<div class="col-xs-12 object-actions-container-modal-menu">';
                btnGroup += '</div>';


                btnGroup += '</div>';
                btnGroup += '</div>';
                btnGroup += '</div>';
                $(btnGroup).insertBefore($(".object-actions-container-btn:eq(3)"));
                for (var i = 3; i < nActions; i++) {
                    $(".object-actions-container-btn:eq(" + i + ")").detach().appendTo(".object-actions-container-modal-menu").css("width", "46%").css("margin", "2%");
                }
                $("#objectActionsContainerModal").detach().insertBefore(".mobileContainer");
            }

            $(".mobileContainer").append($(".object-actions-container").detach());
            $(".mobileContainer").css("min-width", "360px");

            /*Botones fijos en el bottom*/
            $(".mobileContainer").css("padding-bottom", ($(".object-actions-container").height() + 10));
            $(".object-actions-container").css("width", "100%").css("min-width", "340px").css("max-width", "550px");
            $(".object-actions-container").css("position", "fixed").css("bottom", "0").css("margin", "0px").css("padding", "0px").css("z-index", "5");
            $(".object-actions-container").show();
        }

        if ($(".dropdown-main-menu-container").length === 1) {
            /*Dropdown menu with overlay*/
            $(function () {
                $("#header").css("z-index", "11");
                $(".dropdown-main-menu-container").on('show.bs.dropdown', function () {
                    $("body").append('<div id="sidebarOverlay" style="z-index:10;display:block;">&nbsp;-&nbsp;</div>');
                });
                $(".dropdown-main-menu-container").on('hide.bs.dropdown', function () {
                    $("#sidebarOverlay").remove();
                });
            });
        }

    }

    return true;

}

function highlightRequiredField(field)
{
    if (!field.hasClass("auxiliar-input")) {
        if (field.hasClass("required")) {
            field.parents(".input-container").first().addClass("file-field-required");
        } else {
            field.parents(".input-container").first().removeClass("file-field-required");
        }
    }
}

function loadThemeV2Tooltips()
{
    if (AppConfig["templateThemeVersion"] < 2) {
        return false;
    }

    $(".navbar-right .btn, .bottom-tooltip").each(function () {
        $(this).tooltip({
            position: {my: "right top+5", at: "right bottom", "collision": "flipfit"},
            placement: 'bottom',
            tooltipClass: ($(this).data("tooltip-type") ? $(this).data("tooltip-type") : ''),
            html: true,
            content: function () {
                return $(this).prop('title');
            }
        });
    });
    $(".bottom-left-tooltip").each(function () {
        $(this).tooltip({
            position: {my: "left top+5", at: "left bottom", "collision": "flipfit"},
            placement: 'bottom',
            tooltipClass: ($(this).data("tooltip-type") ? $(this).data("tooltip-type") : ''),
            html: true,
            content: function () {
                return $(this).prop('title');
            }
        });
    });
    $(".btn.fa, .top-tooltip").each(function () {
        $(this).tooltip({
            position: {my: "right bottom-5", at: "right top", "collision": "flipfit"},
            tooltipClass: ($(this).data("tooltip-type") ? $(this).data("tooltip-type") : ''),
            html: true,
            content: function () {
                return $(this).prop('title');
            }
        });
    });
    $(".top-left-tooltip").each(function () {
        $(this).tooltip({
            position: {my: "left bottom-5", at: "left top", "collision": "flipfit"},
            tooltipClass: ($(this).data("tooltip-type") ? $(this).data("tooltip-type") : ''),
            html: true,
            content: function () {
                return $(this).prop('title');
            }
        });
    });
    $(".left-tooltip").each(function () {
        $(this).tooltip({
            position: {my: "right-5 center", at: "left center", "collision": "flipfit"},
            placement: 'left',
            tooltipClass: ($(this).data("tooltip-type") ? $(this).data("tooltip-type") : ''),
            html: true,
            content: function () {
                return $(this).prop('title');
            }
        });
    });
    $(".right-tooltip").each(function () {
        $(this).tooltip({
            position: {my: "left+5 center", at: "right center", "collision": "flipfit"},
            placement: 'right',
            tooltipClass: ($(this).data("tooltip-type") ? $(this).data("tooltip-type") : ''),
            html: true,
            content: function () {
                return $(this).prop('title');
            }
        });
    });

    return true;
}

var hasWolfUserInteraction = false;
function checkIfWolfUserInteraction(interactionIn) {
    if ($(interactionIn).lenght) {
        return false;
    }
    $(interactionIn).click(function () {
        hasWolfUserInteraction = true;
    });
}

function wolfUserHasInteraction(set) {
    if (typeof set !== "undefined") {
        hasWolfUserInteraction = set;
    }
    return hasWolfUserInteraction;
}

function warningBeforeunloadIfWolfUserInteraction(interactionIn)
{
    checkIfWolfUserInteraction(interactionIn);

    $(window).bind('beforeunload', function (e) {
        if (!wolfUserHasInteraction()) {
            return undefined;
        }
        wolfUserHasInteraction(false);
        return true;
    });
}
